package facets.core.app;
import static facets.util.app.Events.*;
import facets.core.app.AppSurface.ContentRoot;
import facets.core.app.AppSurface.ContentStyle;
import facets.core.app.AppSurface.Contenter;
import facets.core.superficial.Notice;
import facets.core.superficial.Notifying;
import facets.core.superficial.SFacet;
import facets.core.superficial.SFrameTarget;
import facets.core.superficial.SIndexing;
import facets.core.superficial.STarget;
import facets.core.superficial.Notifying.Impact;
import facets.core.superficial.SIndexing.Coupler;
import facets.core.superficial.app.AreaTargeter;
import facets.core.superficial.app.SAreaTarget;
import facets.core.superficial.app.SContentRootTargeter;
import facets.core.superficial.app.SContenter;
import facets.core.superficial.app.SHost;
import facets.core.superficial.app.ViewableFrame;
import facets.core.superficial.app.SHost.FacetLayout;
import facets.util.Debug;
import facets.util.ItemList;
import facets.util.app.WatchableOperation;
import facets.util.app.Events;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
class AppRoots{
	AreaTargeter targeter;
	final Headless headless;
	private final Map<Class<?extends SContenter>,FacetLayout>layouts=new HashMap();
	private final AppSurface surface;
	private final SAreaTarget emptyRoot;
	private MountFacet surfaceRootFacet;
	private FacetLayout layout;
	AppRoots(AppSurface surface){
		this.surface=surface;
		headless=surface.isHeadless()?new Headless():null;
		emptyRoot=((SContenter)surface.emptyContent).newContentRoot(true,true);
	}
	final class RootsUpdate{
		final private SAreaTarget[]rootsThen=(SAreaTarget[])(targeter==null?new SAreaTarget[]{}
			:headless!=null?headless.surfaceRoot.indexableTargets()
			:(SAreaTarget[])surfaceRoot().indexableTargets());
		final private ItemList<SAreaTarget>roots=new ItemList(SAreaTarget.class);
		private int rootAt=rootsThen.length==0?0:surfaceRoot().indexing().index();
		void addFreshRoot(Contenter content){
			traceEvent(">Adding contenter "+Debug.info(content));
	    if(rootsThen.length>0&&rootsThen[0]!=emptyRoot)
	    	roots.addItems(rootsThen);
	    SAreaTarget add=content==surface.emptyContent?emptyRoot
	    	:((SContenter)content).newContentRoot(true,true);
			roots.addItem(add);
			rootAt=roots.size()-1;
			finishUpdate();
		}
		void addAlignedRoot(Contenter content,int alignAt){
	    SAreaTarget align=rootsThen[alignAt],
	    	add=((SContenter)content).newContentRoot(true, true);
	    content.alignAddedRoot(align,add);
	    for(int i=0;i<rootsThen.length;i++){
				roots.addItem(rootsThen[i]);
				if(i!=alignAt)continue;
				roots.addItem(add);
				rootAt=i+1;
			}
			finishUpdate();
		}
		void removeRoot(SAreaTarget root){
			for(int i=0;i<rootsThen.length;i++)
				if(rootsThen[i]==root)
					rootAt=i>0?i-1:0;
				else roots.addItem(rootsThen[i]);
			finishUpdate();
		}
		void removeContentRoots(Contenter content){
			ViewableFrame viewable=
				(ViewableFrame)((ViewerContenter)content).contentFrame();
			for(int i=0;i<rootsThen.length;i++)
				if(rootsThen[i].activeContent()==viewable)
					rootAt-=rootAt==0?0:1;
				else roots.addItem(rootsThen[i]);
			finishUpdate();
		}
		void replaceActiveRoot(Contenter content){
			SAreaTarget rootThen=(SAreaTarget)surfaceRoot().indexedTarget(),
				rootNow=((SContenter)content).newContentRoot(false, true);
			boolean isHeadless=headless!=null;
		  if(!isHeadless&&rootNow.getClass()!=rootThen.getClass())
		  	throw new RuntimeException("Non-matching areas in "+Debug.info(surface));
		  else if(!isHeadless)rootNow.attachThenFacets(rootThen);
		  for(SAreaTarget root:rootsThen)
		  	if(root==rootThen){
					roots.addItem(rootNow);
					rootAt=roots.size()-1;
				}
		  	else if(root.activeContent()!=rootThen.activeContent())
		  		roots.addItem(root);
		  finishUpdate();
		}
		private void finishUpdate(){
			WatchableOperation op=new WatchableOperation("AppRoots.RootsUpdate.finishUpdate"){
				@Override
		public void doSimpleOperation(){
			boolean isHeadless=headless!=null;
		  SAreaTarget[]rootsNow=roots.items();
		  if(rootsNow.length==0)rootsNow=new SAreaTarget[]{emptyRoot};
			boolean emptyNow=rootsNow[0]==emptyRoot;
		  MountFacet[]rootFacets=null;
			if(!emptyNow){
				Map<SFrameTarget,Integer>counts=new HashMap<SFrameTarget,Integer>();
				for(int i=0;i<rootsNow.length;i++){
					SFrameTarget viewable=rootsNow[i].activeContent();
					Integer count=counts.get(viewable);
					int useCount=count==null?0:count;
					counts.put(viewable,++useCount);
				}
				for(int i=0;i<rootsNow.length;i++){
					SFrameTarget viewable=rootsNow[i].activeContent();
					int count=counts.get(viewable);
					if(count==1)counts.put(viewable,0);
				}
				for(int i=rootsNow.length-1;i>=0;i--){
					SFrameTarget viewable=rootsNow[i].activeContent();
					int useCount=counts.get(viewable);
					ContentRoot contentRoot=((ContentRoot)rootsNow[i]);
					String superTitle=contentRoot.superTitle();
					contentRoot.setUseTitle(superTitle+(useCount>0?":"+useCount:""));
					counts.put(viewable,--useCount);
				}
				rootFacets=new MountFacet[rootsNow.length];
			  if(!isHeadless)for(int i=0;i<rootFacets.length;i++)
			  	rootFacets[i]=(MountFacet)rootsNow[i].attachedFacet();
			}
			SAreaTarget surfaceRoot=newSurfaceRoot(rootsNow);
		  if(isHeadless){
		  	headless.surfaceRoot=surfaceRoot;
		  	if(!emptyNow)return;
		  }
			surfaceRoot.indexing().setIndex(rootAt);
		  if(isHeadless&&!emptyNow)throw new IllegalStateException(
		  		"Headless in "+Debug.info(this));
			if((surfaceRootFacet==null))
				surfaceRootFacet=isHeadless?headless.newRootFacet(surfaceRoot)
		  			:surface.contentStyle==ContentStyle.SINGLE?rootFacets[0]
			  		:surface.newMultiContentFacet(surfaceRoot);
			surfaceRoot.attachFacet(surfaceRootFacet);
			if(emptyNow){
				rootsNow[0].attachFacet(surfaceRootFacet);
			  surfaceRootFacet.setFacets(new SFacet[]{});
			}
			if(rootFacets!=null&&surfaceRootFacet!=rootFacets[0])
			  surfaceRootFacet.setFacets(rootFacets);
		  if(targeter==null&&(
		  		targeter=isHeadless?Headless.newRootTargeter()
		  			:(AreaTargeter)surfaceRoot.newTargeter())==null)
		    throw new IllegalStateException("Null targeter in "+Debug.info(this));
		  targeter.retarget(surfaceRoot,Notifying.Impact.DEFAULT);
			targeter.setMonitor(surface);
			targeter.retargetFacets(Impact.DEFAULT);
		}};
			if(false)surface.runWatched(op);
			else op.doSimpleOperation();
		}
	}
  private SAreaTarget newSurfaceRoot(SAreaTarget[]roots){
		Coupler coupler=new Coupler(){
			public String[]newIndexableTitles(SIndexing in){
				SAreaTarget[]areas=(SAreaTarget[])in.indexables();
				String[]titles=new String[areas.length];
				for(int i=0;i<titles.length;i++)
					titles[i]=(i+1)+" "+areas[i].title();
				return titles;
			}
		};
		return new SAreaTarget(surface.title(),
				new SIndexing("Content Roots",roots,0,coupler)){
		  protected STarget[]lazyElements(){
				return surface.lazySurfaceRootElements();
			}
		};
	}
	final void updateLayout(final List<Contenter>contents){
		WatchableOperation op=new WatchableOperation("AppRoots.updateLayout"){
		public void doSimpleOperation(){
	  	if(headless!=null)throw new RuntimeException("headless");;
			Events.traceEvent(">Laying out surface "+Debug.info(surface));
		  Contenter first=contents.get(0),active=first;
		  SContentRootTargeter activeTargeter=
		  	headless!=null?Headless.newContentRootTargeter()
		  			:(SContentRootTargeter)targeter.area(AppSurface.AREA_CONTENT);
		  SAreaTarget activeRoot=(SAreaTarget)activeTargeter.target();
			if(first instanceof ViewerContenter)
				for(Contenter content:contents)
					if(((ViewerContenter)content).contentFrame()==activeRoot.activeContent())
						active=content;
		  ((SContenter)active).rootRetargeted(activeTargeter);
		  surface.surfaceRetargeted();
			Events.traceEvent(">Getting layout for "+activeTargeter);
		  layout=layouts.get(active.getClass());
		  SHost host=surface.host();
			if(layout==null)layouts.put(active.getClass(),
					layout=active.newContentLayout(host,surfaceRootFacet,activeTargeter));
			Events.traceEvent(">Passing layout " +Debug.info(layout)+" of "+layouts.size()
					+" to host " +Debug.info(host));
			host.setLayout(layout);
		  surface.notify(new Notice(activeRoot,Notifying.Impact.DEFAULT));
			Events.traceEvent(">Updated surface for "+Debug.info(surface));
			Debug.memCheck("AppRoots.updateLayout: ",true);
		}};
		if(false)op.doSimpleOperation();
		else surface.runWatched(op);
	}
	final SAreaTarget surfaceRoot(){
		if(headless!=null)return headless.surfaceRoot;
		if(targeter==null)throw new IllegalStateException("No targeter in "+Debug.info(surface));
		return((SAreaTarget)targeter.target());
	}
}
/*/*
This file forms part of Version 0.8.79 of Facets, a framework demonstrating 
the Superficial approach to GUI-driven interactive applications.  
http://superficial.sourceforge.net 				
Copyright (C) 2011  David M Wright 
This library is free software; you can redistribute it and/or modify it under 
the terms of the GNU Lesser General Public License as published by the 
Free Software Foundation; either release 3 of the License, or (at your 
option) any later release.
This library is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR 
A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more 
details.
You should have received a copy of the GNU Lesser General Public License along 
with this library; if not, write to the Free Software Foundation, Inc., 
59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/

