package facets.core.app;
import facets.util.Debug;
import facets.util.Objects;
import facets.util.OffsetPath;

import java.util.Arrays;
/**
{@link OffsetPath} for array-based content. 
 */
final public class ArrayPath extends OffsetPath{
	public ArrayPath(Object[]members){
		super(members);
	}
  public ArrayPath(Object[]array,int index){
		this(new Object[]{array,array[index]});
	}
  public ArrayPath(Object[]array,Object indexed){
		this(new Object[]{array,indexed});
	}
  public ArrayPath(int[]offsets){
  	super(offsets);
	}
	protected int[]newOffsets(Object[]members){
    if(members.length!=2)throw new IllegalArgumentException("Bad members in "+Debug.info(this));
    Object array[]=(Object[])members[0],node=members[1];
    for(int i=0;i<array.length;i++)if(array[i]==node)return new int[]{0,i};
    throw new RuntimeException("Node " + Debug.info(node)+" not found in root "+Debug.info(array));
  }    
  protected Object[]newMembers(Object root,int[]indices){
    if(indices.length==1)return new Object[]{root};
    Object[]array=(Object[])root;
    return new Object[]{array,array[indices[1]]};
  }
	/**
	Invalid stub implementation. 
	 */
	public OffsetPath procrusted(Object root,Object to){
		throw new RuntimeException("Not implemented in "+Debug.info(this));
	}
}/*/*
This file forms part of Version 0.8.79 of Facets, a framework demonstrating 
the Superficial approach to GUI-driven interactive applications.  
http://superficial.sourceforge.net 				
Copyright (C) 2011  David M Wright 
This library is free software; you can redistribute it and/or modify it under 
the terms of the GNU Lesser General Public License as published by the 
Free Software Foundation; either release 3 of the License, or (at your 
option) any later release.
This library is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR 
A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more 
details.
You should have received a copy of the GNU Lesser General Public License along 
with this library; if not, write to the Free Software Foundation, Inc., 
59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/
