package facets.core.app;
import static facets.util.datatree.Nodes.*;
import facets.core.superficial.app.SSelection;
import facets.core.superficial.app.SViewer;
import facets.util.Debug;
import facets.util.OffsetPath;
import facets.util.Util;
import facets.util.datatree.DataNode;
import facets.util.datatree.Nodes;
import facets.util.datatree.TypedNode;
import java.util.ArrayList;
import java.util.List;
/**
{@link TextView} displaying rich text defined using HTML. 
 */
public abstract class HtmlView extends TextView{
	public static boolean showSource;
	/** Key/node type for HTML source. */
	public static final String KEY_SOURCE="htmlSource";
	public HtmlView(String title){
		super(title);
	}
	/**
	Instructs the viewer to display the HTML source. 
	<p>Default returns {@link #showSource}. 
	 */
	public boolean showSource(){
		return showSource;
	}
	/**
	Re-implementation returning <code>true</code> for rich text. 
	 */
	public boolean wrapLines(){
		return true;
	}
	/**
	Allows optimised rendering by truncation of content to fit viewer size. 
	<p>If the associated {@link SViewer} returns as {@link SSelection#content()} a 
	{@link String}[] of lines, the viewer facet can optimise by only rendering a subset of 
	these; to do so it needs an estimate of height of each line.   
	@return by default -1 to signal no value; or estimated pixel height of each line
	 */
	public int quickLineHeight(){
		return -1;
	}
}
/*/*
This file forms part of Version 0.8.79 of Facets, a framework demonstrating 
the Superficial approach to GUI-driven interactive applications.  
http://superficial.sourceforge.net 				
Copyright (C) 2011  David M Wright 
This library is free software; you can redistribute it and/or modify it under 
the terms of the GNU Lesser General Public License as published by the 
Free Software Foundation; either release 3 of the License, or (at your 
option) any later release.
This library is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR 
A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more 
details.
You should have received a copy of the GNU Lesser General Public License along 
with this library; if not, write to the Free Software Foundation, Inc., 
59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/

