package facets.core.app.avatar;
import facets.core.app.PathSelection;
import facets.core.superficial.app.SSelection;
import facets.core.superficial.app.SViewer;
import facets.core.superficial.app.SelectionView;
import facets.util.Debug;
/**
{@link SelectionView} that (partially) implements {@link AvatarView}.
	<p>Major policy methods delegate to the {@link AvatarPolicies} passed to 
	the constructor. 
 */
public abstract class AvatarViewWorks extends SelectionView implements AvatarView{
	protected final AvatarPolicies avatars;
  public AvatarViewWorks(String title,AvatarPolicies avatars){
		super(title);
		this.avatars=avatars;
	}
  @Override
  final public AvatarPolicies avatars(){
  	return avatars;
  }
  /**
	Implements interface method. 
	<p>Returns <code>false</code>. 
	 */
	public boolean allowMultipleSelection(){
		return false;
	}
	/**
	Implements interface method. 
	<p>Returns <code>false</code>. 
	 */
	public boolean doesDnD(){return false;}
}
/*/*
This file forms part of Version 0.8.79 of Facets, a framework demonstrating 
the Superficial approach to GUI-driven interactive applications.  
http://superficial.sourceforge.net 				
Copyright (C) 2011  David M Wright 
This library is free software; you can redistribute it and/or modify it under 
the terms of the GNU Lesser General Public License as published by the 
Free Software Foundation; either release 3 of the License, or (at your 
option) any later release.
This library is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR 
A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more 
details.
You should have received a copy of the GNU Lesser General Public License along 
with this library; if not, write to the Free Software Foundation, Inc., 
59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/

