package facets.core.superficial;
import facets.core.superficial.Notifying.Impact;
import facets.util.Debug;
import java.util.ArrayList;
import java.util.List;
/**
Object to be passed by {@link Notifying} to {@link Notifiable}.
 */
public class Notice{
	public final Impact impact;
	public final List<Notifying>sources=new ArrayList();
	public Notice(Notifying source,Impact impact){
		this.impact=impact;
		addSource(source);
	}
	final public Notice addSource(Notifying source){
		if(source==null)throw new IllegalArgumentException(
				"Null source in "+Debug.info(this));
		sources.add(source);
		return this;
	}
	public String toString(){
		return Debug.info(this)+" "+impact+
		"\n\t"+Debug.arrayInfo(sources.toArray()).replaceAll("\n",",");
	}
	public String flashText(){
		throw new RuntimeException("Not implemented in "+Debug.info(this));
	}
}
/*/*
This file forms part of Version 0.8.79 of Facets, a framework demonstrating 
the Superficial approach to GUI-driven interactive applications.  
http://superficial.sourceforge.net 				
Copyright (C) 2011  David M Wright 
This library is free software; you can redistribute it and/or modify it under 
the terms of the GNU Lesser General Public License as published by the 
Free Software Foundation; either release 3 of the License, or (at your 
option) any later release.
This library is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR 
A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more 
details.
You should have received a copy of the GNU Lesser General Public License along 
with this library; if not, write to the Free Software Foundation, Inc., 
59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/

