package facets.facet;
import static facets.facet.AreaFacets.*;
import static java.util.Arrays.*;
import facets.core.app.DialogSurface;
import facets.core.superficial.SFacet;
import facets.core.superficial.STarget;
import facets.core.superficial.STargeter;
import facets.core.superficial.SToggling;
import facets.core.superficial.STrigger;
import facets.core.superficial.TargetCore;
import facets.core.superficial.SToggling.Coupler;
import facets.core.superficial.SToggling.Togglings;
import facets.core.superficial.app.SContentRootTargeter;
import facets.facet.app.FacetDialogContenter;
import facets.facet.app.FacetDialogSurface;
import facets.util.ItemList;
import java.awt.Dimension;
final class PaneSetContenter extends FacetDialogContenter{
	final static String TITLE="Select Panes";
	private final PaneSetLayout layout;
	private final int[]copyTabs,copyHides;
	private final SToggling defaults,ask;
	private final STarget options,tree[];
	private final int copyFlip;
	private final boolean copyAsk;
	private boolean okPressed;
	private DialogSurface dialog;
	protected boolean aligning;
	private final PaneSet panes;
	PaneSetContenter(FacetFactory ff,final PaneSetLayout layout,PaneSet panes,
			STarget flipReset,STarget ask){
		super(TITLE,ff);
		this.layout=layout;
		this.panes=panes;
		copyTabs=layout.tabs.stateInts();
		copyHides=layout.shows.stateInts();
		copyFlip=layout.flip;
		copyAsk=(this.ask=(SToggling)ask).isSet();
		Togglings tabs=new Togglings(layout.tabs.togglings,copyTabs){
			@Override
			protected void togglingSet(int at){
				if(!aligning)layout.tabs.togglings[at].set(togglings[at].isSet());
			}
		},
		shows=new Togglings(layout.shows.togglings,copyHides){
			@Override
			protected boolean zeroAsTrue(){
				return true;
			}
			@Override
			protected void togglingSet(int at){
				if(!aligning)layout.shows.togglings[at].set(togglings[at].isSet());
			}
		};
		final ItemList<STarget>targets=new ItemList(STarget.class);
		for(int showsNextAt=0,codesAt=1;codesAt<layout.codesTree.length;codesAt++){
			int showsCount=1+(layout.codesTree[codesAt].length+1)/2;
			targets.add(new TargetCore(layout.groups[codesAt-1],
				copyOfRange(shows.togglings,showsNextAt,showsNextAt+showsCount)));
			showsNextAt+=showsCount;
		}
		defaults=new SToggling(PANE_KEY_DEFAULT,false,new Coupler());
		options=new TargetCore("Options",defaults,ask);
		final STarget triggers[]=flipReset.elements(), 
			flip=new STrigger(triggers[0].title(),new STrigger.Coupler(){
				public void fired(STrigger t){
					((STrigger)triggers[0]).fire();
				}
			}),
		reset=new STrigger(triggers[1].title(),new STrigger.Coupler(){
			public void fired(STrigger t){
				((STrigger)triggers[1]).fire();
			}
		}),
		showOptions=new SToggling("ShowOptions|"+options.title()+">>",
				layout.showOptions,new Coupler(){
			@Override
			public void stateSet(SToggling t){
				options.setLive(layout.showOptions=t.isSet());
				if(false)traceDebug(".stateSet: showOptions="+layout.showOptions+" options=",options);
			}
		});
		options.setLive(layout.showOptions);
		if(false)trace(": showOptions="+layout.showOptions+" options=",options);
		tree=new STarget[]{
			new TargetCore("Shows",shows.togglings),
			new TargetCore("Groups",targets.items()),
			new TargetCore("Buttons",flip,reset),
			new TargetCore("Show in Tabs",tabs.togglings),
			options,
			showOptions
		};
	}
	@Override
	public void rootRetargeted(SContentRootTargeter t){
		STargeter[]shows=t.elements()[0].elements(),
			tabs=t.elements()[3].elements();
		aligning=true;
		for(int i=0;i<shows.length;i++){
			SToggling here=(SToggling)shows[i].target(),there=layout.shows.togglings[i];
			here.setLive(there.isLive());
			here.set(there.isSet());
		}
		for(int i=0;i<tabs.length;i++){
			SToggling here=(SToggling)tabs[i].target(),there=layout.tabs.togglings[i];
			here.set(there.isSet());
		}
		aligning=false;
	}
	@Override
	protected PanelFacets newPanelFacets(FacetFactory core){
		return new PanelFacets(core){
			@Override
			public SFacet newContentPanel(SContentRootTargeter t){
				final ItemList<SFacet>core=new ItemList(SFacet.class);
				STargeter elements[]=t.elements(),
					groups[]=elements[1].elements(),
					buttons=elements[2],tabs=elements[3],
					options=elements[4],showOptions=elements[5];
				for(STargeter group:groups)core.add(togglingCheckboxes(group,HINT_TALL));
				core.addItems(
					rowPanel(buttons,0,10,HINT_PANEL_RIGHT,
						triggerButtons(buttons,HINT_TALL+HINT_BARE+HINT_USAGE_PANEL),BREAK,
						togglingButtons(showOptions,HINT_BARE+HINT_TITLE2)),
					BREAK,togglingCheckboxes(tabs,HINT_NONE),
					BREAK,fill());
				((FacetDialogSurface)dialog).addExtensionPanel(rowPanel(options,10,15,HINT_NONE,
						togglingCheckboxes(options,HINT_TALL+HINT_BARE)),true);
				return rowPanel(t,10,0,HINT_PANEL_INSET,core.items());
			}
		};
	}
	@Override
	public Dimension contentAreaSize(){
		return new Dimension(270,100);
	}
	@Override
	public void setDialog(DialogSurface dialog){
		this.dialog=dialog;
	}
	@Override
	protected STarget[]lazyContentRootElements(){
		return tree;
	}
	@Override
	public void applyChanges(){
		okPressed=true;
	}
	@Override
	public void reverseChanges(){
		layout.tabs.setStates(copyTabs);
		layout.shows.setStates(copyHides);
		layout.flip=copyFlip;
		ask.set(copyAsk);
		panes.applyLayout();
	}
	@Override
	public void dialogClosed(){
		if(!okPressed)reverseChanges();
		else layout.storeState(defaults.isSet());
	}
}/*/*
This file forms part of Version 0.8.79 of Facets, a framework demonstrating 
the Superficial approach to GUI-driven interactive applications.  
http://superficial.sourceforge.net 				
Copyright (C) 2011  David M Wright 
This library is free software; you can redistribute it and/or modify it under 
the terms of the GNU Lesser General Public License as published by the 
Free Software Foundation; either release 3 of the License, or (at your 
option) any later release.
This library is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR 
A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more 
details.
You should have received a copy of the GNU Lesser General Public License along 
with this library; if not, write to the Free Software Foundation, Inc., 
59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/
