package facets.facet;
import static facets.core.app.DialogActionDefaults.*;
import static facets.facet.AreaFacets.*;
import static facets.util.Strings.*;
import static java.util.Arrays.*;
import facets.core.app.DialogHost;
import facets.core.app.DialogSurface;
import facets.core.app.DialogSurface.Contenter;
import facets.core.app.DialogSurface.DialogActions;
import facets.core.app.Dialogs.Surfacer;
import facets.core.superficial.SNumeric;
import facets.core.superficial.STarget;
import facets.core.superficial.SToggling;
import facets.core.superficial.STrigger;
import facets.core.superficial.TargetCore;
import facets.core.superficial.SToggling.Coupler;
import facets.core.superficial.SToggling.Togglings;
import facets.core.superficial.app.SAreaTarget;
import facets.core.superficial.app.SSurface;
import facets.facet.app.FacetAppSurface;
import facets.facet.app.FacetDialogSurface;
import facets.util.Debug;
import facets.util.NumberPolicy;
import facets.util.NumberValues;
import facets.util.Tracer;
import facets.util.datatree.Nodes;
import facets.util.datatree.ValueNode;
import java.util.Arrays;
final class PaneSetLayout extends Tracer{
	private class Numbers extends NumberValues{
		Numbers(Object defaultValue,int checkCount,String keyTop){
			super(defaultValue,checkCount,keyTop);
		}
		@Override
		protected String keyTailDefaults(){
			return Nodes.keySafe(getClass().getName());
		}
		@Override
		protected String keyTailSession(){
			return keyTailTitle;
		}
		@Override
		protected ValueNode store(){
			return state;
		}
	}
	final SAreaTarget area;
	final int[][]codesTree;
	final String[]groups;
	int flip;
	Togglings tabs,shows;
	SNumeric[]splits;
	boolean showOptions;
	final private STarget areas[],ask;
	private final NumberValues flipValue,tabAndHideValues,splitValues;
	final private ValueNode state;
	final private String keyTailTitle;	
	private STarget flipReset,show,active,maximise,restore,select;
	private boolean resetting;
	private Boolean doValidate;
	PaneSetLayout(SAreaTarget area,ValueNode state,String title,
			int[][]codesTree,double[]splitDefaults,int[]tabAndHideDefaults,String[]groups){
		this.area=area;
		this.codesTree=codesTree;
		this.state=state;
		keyTailTitle=Nodes.keySafe(title);
		areas=area.indexableTargets();
		int groupCount=codesTree.length-1;
		if(groups.length!=groupCount){
			groups=new String[groupCount];
			for(int i=0;i<groups.length;i++)groups[i]="Group"+i;
		}
		this.groups=groups;
		flipValue=new Numbers(PANE_SPLIT_VERTICAL,1,PANE_KEY_FLIP);
		splitValues=new Numbers(splitDefaults,areas.length-1,PANE_KEY_SPLITS){
			protected double[]validDefaultDoubles(double[]proposed){
				double[]supers=super.validDefaultDoubles(proposed);
				if(proposed.length==0)Arrays.fill(supers,1d/areas.length);
				return supers;
			}
		};
		tabAndHideValues=new Numbers(
				tabAndHideDefaults,groups.length+areas.length,PANE_KEY_TAB_AND_HIDE);
		ask=new SToggling(PANE_KEY_ASK,state.getOrPutBoolean(PANE_KEY_ASK,true),
				new Coupler(){
			@Override
			public void stateSet(SToggling t){
				PaneSetLayout.this.state.put(PANE_KEY_ASK,t.isSet());
			}
		});
	}
	@Override
	protected void traceOutput(String msg){
		if(true)super.traceOutput(msg);
	}
	void panesLaidOut(boolean maximisedActive){
		int displayed=0;
		for(SToggling t:shows.togglings)if(t.isSet())displayed++;
		boolean oneDisplayed=displayed==1;
		for(SToggling t:shows.togglings)if(t.isSet())t.setLive(!oneDisplayed);
		show.setLive(!maximisedActive);
		select.setLive(show.isLive());
		maximise.setLive(!maximisedActive&&!oneDisplayed);
		restore.setLive(maximisedActive);
		flipReset.setLive(!maximisedActive&&areas.length>1);
		flipReset.elements()[0].setLive(flipReset.isLive()&&!oneDisplayed);
		storeState(false);
	}
	void validate(){
		if(false)trace(".validate: doValidate=",doValidate);
		if(((SToggling)ask).isSet()&&doValidate)((STrigger)select).fire();
		doValidate=false;
	}
	STarget buildPaneTargets(final PaneSet panes){
		flip=(Integer)flipValue.getValue(false);
		SNumeric.Coupler splitCoupler=new SNumeric.Coupler(){
			public NumberPolicy policy(SNumeric n){
				return SASH_SPLIT_POLICY;
			}
			public void valueSet(SNumeric n){
				if(!resetting)storeState(false);
			}
		};
		double[]splitFetch=(double[])splitValues.getValue(false);
		splits=new SNumeric[splitFetch.length];
		for(int i=0;i<splits.length;i++)
			splits[i]=new SNumeric("Split",splitFetch[i]*100,splitCoupler);
		int[]tabAndHideFetch=(int[])tabAndHideValues.getValue(false);
		tabs=new Togglings(groups,copyTabInts(tabAndHideFetch)){
			@Override
			protected void togglingSet(int at){
				if(!resetting)panes.applyLayout();
			}
		};
		shows=new Togglings(areas,copyHideInts(tabAndHideFetch)){
			@Override
			protected boolean zeroAsTrue(){
				return true;
			}
			@Override
			protected void togglingSet(int at){
				if(resetting)return;
				STarget active=null;
				if(togglings[at].isSet())active=areas[at];
				else for(int i=0;active==null&&i<areas.length;i++)
					if(togglings[i].isSet())active=areas[i];
				if(active==null)throw new IllegalStateException(
						"Null active in "+Debug.info(this));
				else((SAreaTarget)active).ensureActive(false);
				panes.applyLayout();
			}
		};
		STrigger.Coupler maximiseCoupler=new STrigger.Coupler(){
			public void fired(STrigger t){
				panes.setMaximisedActive(t==maximise);
			}
		};
		return new TargetCore(PaneSet.class.getSimpleName(),
			flipReset=new TargetCore("Layout",
				new STrigger(PANE_FLIP,new STrigger.Coupler(){
					public void fired(STrigger t){
						flip=flip==PANE_SPLIT_VERTICAL?PANE_SPLIT_HORIZONTAL:PANE_SPLIT_VERTICAL;
						panes.applyLayout();
					}
			  }),
			  new STrigger(PANE_RESET,new STrigger.Coupler(){
				  public void fired(STrigger t){
						resetting=true;
						flip=(Integer)flipValue.getValue(true);
						double[]splitFetch=(double[])splitValues.getValue(true);
						for(int i=0;i<splits.length;i++)splits[i].setValue(splitFetch[i]*100);
						int[]tabAndHide=(int[])tabAndHideValues.getValue(true);
						tabs.setStates(copyTabInts(tabAndHide));
						shows.setStates(copyHideInts(tabAndHide));
						resetting=false;
				  	panes.applyLayout();
					}
				})),
			show=new TargetCore("Sho&w Panes",shows.togglings),
			active=new TargetCore("Active",
				maximise=new STrigger("Ma&ximise Active",maximiseCoupler),
				restore=new STrigger("Restore All",maximiseCoupler)),
			select=new STrigger(PaneSetContenter.TITLE+"...",new STrigger.Coupler(){
				@Override
				public void fired(STrigger t){
					FacetAppSurface app=TargetCore.findMonitorOfType(FacetAppSurface.class,
							area);
					if(app==null)throw new IllegalStateException("Null app in "+Debug.info(this));
					app.dialogs().launchSurfaced(new Surfacer(){
							@Override
							protected DialogSurface newSurface(SSurface parent,
									DialogHost host,String title,DialogActions actions,Contenter[]contents){
								return new FacetDialogSurface((FacetAppSurface)parent,host,title,
										actions,contents){
									public boolean isResizable(){
										return true;
									}
								};
							}
						},PaneSetContenter.TITLE,newOkCancel(),
						new PaneSetContenter(app.ff,PaneSetLayout.this,panes,flipReset,ask));
				}
			})	
		);
	}
	private int[]copyHideInts(int[]tabAndHide){
		return copyOfRange(tabAndHide,groups.length,tabAndHide.length);
	}
	private int[]copyTabInts(int[]tabAndHide){
		return copyOfRange(tabAndHide,0,groups.length);
	}
	void storeState(boolean asDefaults){
		if(doValidate==null)doValidate=!flipValue.hasSessionValue();
		if(false)trace(".storeState: doValidate=",doValidate);
		flipValue.putValue(flip,asDefaults);
		double[]splits=new double[this.splits.length];
		for(int i=0;i<splits.length;i++)splits[i]=this.splits[i].value()/100;
		splitValues.putValue(splits,asDefaults);
		String tabs=intsString(this.tabs.stateInts());
		tabAndHideValues.putValue(tabs+(tabs.equals("")?"":",")+intsString(shows.stateInts()),
				asDefaults);
	}
}/*/*
This file forms part of Version 0.8.79 of Facets, a framework demonstrating 
the Superficial approach to GUI-driven interactive applications.  
http://superficial.sourceforge.net 				
Copyright (C) 2011  David M Wright 
This library is free software; you can redistribute it and/or modify it under 
the terms of the GNU Lesser General Public License as published by the 
Free Software Foundation; either release 3 of the License, or (at your 
option) any later release.
This library is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR 
A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more 
details.
You should have received a copy of the GNU Lesser General Public License along 
with this library; if not, write to the Free Software Foundation, Inc., 
59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/
