package facets.facet;
import facets.core.app.FrameGroup;
import facets.core.superficial.Notifying;
import facets.core.superficial.SIndexing;
import facets.core.superficial.SNumeric;
import facets.core.superficial.STarget;
import facets.core.superficial.STargeter;
import facets.core.superficial.STextual;
import facets.core.superficial.SToggling;
import facets.core.superficial.STrigger;
import facets.core.superficial.TargetCore;
import facets.core.superficial.Notifying.Impact;
import facets.facet.toolkit.KButton;
import facets.facet.toolkit.KWidget;
import facets.facet.toolkit.KWrap;
import facets.facet.toolkit.Kit;
import facets.util.Debug;
import facets.util.StringFlags;
import facets.util.Util;
import java.util.Map;
import javax.swing.JComponent;
final class SimpleCore extends FacetCore implements SwingPanelFacet{
	final public Map<String,JComponent>components(){
		return(Map<String,JComponent>)((KWidget)parts()[0]).components();
	}
	final Class singleTargetClass;
	private final SimpleMaster master;
	@Override
	final protected void traceOutput(String msg){
		super.traceOutput(msg);
	}
	SimpleCore(STargeter link,SimpleMaster master,Kit toolkit){
		super(findContentTarget(link.target()),toolkit);
		singleTargetClass=target.getClass();
		(this.master=master).core=this;
		master.attachedToFacet();
		retarget(target,Notifying.Impact.DEFAULT);
		link.attachFacet(this);
	}
	private static STarget findContentTarget(STarget target){
		return target instanceof SIndexing
				||target instanceof SToggling
				||target instanceof SNumeric
				||target instanceof STrigger
				||target instanceof STextual
				||target.elements().length==0?
			target:target.elements()[0];
	}
	public void targetNotify(Object msg,boolean interim){
		super.targetNotify(msg,interim);
		boolean isSingle=singleTargetClass.isInstance(target);
		if(isSingle)master.notifyingSingle(target,msg);
		else{
			if(false)traceDebug(".targetNotify: singleTargetClass="
					+singleTargetClass.getSimpleName()+" target=",target);
			master.notifyingMultiple(target.elements(),msg);
			Notifying check=target;
			while(!((check=(Notifying)check.monitor())instanceof FrameGroup));
			((FrameGroup)check).facetNotified(interim);
		}
		target.notifyMonitor(target.impact());
	}
	final public void retarget(STarget target,Notifying.Impact impact){
		super.retarget(target,impact);
		boolean minimal=impact==Notifying.Impact.FLASH;
		boolean isSingle=singleTargetClass.isInstance(target);
		if(false)traceDebug(".retarget: isSingle="+isSingle+" target=",target);
		if(isSingle)
			master.retargetedSingle(target,impact);
		else if(!minimal)
			master.retargetedMultiple(target.elements(), impact);
		if(!minimal&&target.wantsFocus())master.respondTargetWantsFocus();
	}
	KButton[]newRegisteredButtons(int type,int usage,String[]titles,
			StringFlags hints){
		if(titles==null)
				throw new IllegalArgumentException("Null titles or keys in "+Debug.info(this));
		KButton[]buttons=kit.buttons(this,type,usage,titles,hints);
		for(int i=0;i<buttons.length;i++)registerPart(buttons[i]);
		return buttons;
	}
	protected void setEnablesToTarget(){
		super.setEnablesToTarget();
		master.setEnables(target());
	}
  public String toString(){
  	return super.toString()+" "+master;
  }
	KWrap lazyBase(){
		return master.newBaseWrap();
	}
	KWrap[]lazyParts(){
		return master.newPartWraps();
	}
}/*/*
This file forms part of Version 0.8.79 of Facets, a framework demonstrating 
the Superficial approach to GUI-driven interactive applications.  
http://superficial.sourceforge.net 				
Copyright (C) 2011  David M Wright 
This library is free software; you can redistribute it and/or modify it under 
the terms of the GNU Lesser General Public License as published by the 
Free Software Foundation; either release 3 of the License, or (at your 
option) any later release.
This library is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR 
A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more 
details.
You should have received a copy of the GNU Lesser General Public License along 
with this library; if not, write to the Free Software Foundation, Inc., 
59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/
