package facets.facet;
import facets.core.superficial.STarget;
import facets.facet.toolkit.KWrap;
import facets.facet.toolkit.Kit;
class Spacer extends FacetCore{
  private final int width,height;
  Spacer(Kit kit){
		this(0,kit);
	}
  Spacer(int width,Kit kit){
		this(width,0,kit);
	}
  Spacer(int width,int height,Kit kit){
		super(STarget.NONE,kit);
		this.width=width;
		this.height=height;
	}
	protected KWrap lazyBase(){
		return kit.spacer(this,width,height);
	}
  protected KWrap[]lazyParts(){return null;}
	final static class Filler extends Spacer{
	  Filler(Kit kit){
			super(0,0,kit);
		}
		protected KWrap lazyBase(){
			return kit.filler(this);
		}
	}
}
/*/*
This file forms part of Version 0.8.79 of Facets, a framework demonstrating 
the Superficial approach to GUI-driven interactive applications.  
http://superficial.sourceforge.net 				
Copyright (C) 2011  David M Wright 
This library is free software; you can redistribute it and/or modify it under 
the terms of the GNU Lesser General Public License as published by the 
Free Software Foundation; either release 3 of the License, or (at your 
option) any later release.
This library is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR 
A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more 
details.
You should have received a copy of the GNU Lesser General Public License along 
with this library; if not, write to the Free Software Foundation, Inc., 
59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/

