package facets.facet;
import facets.core.superficial.SIndexing;
import facets.core.superficial.STarget;
import facets.core.superficial.STrigger;
import facets.facet.toolkit.KButton;
import facets.facet.toolkit.KWrap;
import facets.util.Debug;
import facets.util.Objects;
import facets.util.StringFlags;
import facets.util.Util;
class TriggerButton extends SimpleMaster{
	private KButton button;
	private final int usage;
	TriggerButton(int usage,StringFlags hints){
    super(hints);
    this.usage=usage;
  }
  public void attachedToFacet(){
  	button=core.newRegisteredButtons(KButton.TYPE_FIRE,usage,
  			new String[]{title()},hints)[0];
  }
	protected void notifyingSingle(STarget t,Object msg){
	  if(t instanceof STrigger)((STrigger)t).fire();
	}
	void setEnables(STarget target){
		if(false)trace(".setEnables: ",Debug.info(target)+": "+target.isLive());
    button.setEnabled(target.isLive());
  }
	KWrap newBaseWrap(){return button;}
	KWrap[]newPartWraps(){
		return null;
	}
}
/*/*
This file forms part of Version 0.8.79 of Facets, a framework demonstrating 
the Superficial approach to GUI-driven interactive applications.  
http://superficial.sourceforge.net 				
Copyright (C) 2011  David M Wright 
This library is free software; you can redistribute it and/or modify it under 
the terms of the GNU Lesser General Public License as published by the 
Free Software Foundation; either release 3 of the License, or (at your 
option) any later release.
This library is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR 
A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more 
details.
You should have received a copy of the GNU Lesser General Public License along 
with this library; if not, write to the Free Software Foundation, Inc., 
59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/

