package facets.facet;
import static facets.util.app.Events.*;
import facets.core.superficial.Notifying;
import facets.core.superficial.SFacet;
import facets.core.superficial.SFrameTarget;
import facets.core.superficial.STarget;
import facets.core.superficial.STargeter;
import facets.core.superficial.Notifying.Impact;
import facets.core.superficial.STarget.Targeted;
import facets.core.superficial.app.SAreaTarget;
import facets.core.superficial.app.ViewerTarget;
import facets.facet.toolkit.KMount;
import facets.facet.toolkit.KViewer;
import facets.facet.toolkit.KWrap;
import facets.facet.toolkit.Kit;
import facets.facet.toolkit.KitFacet;
import facets.util.Debug;
import facets.util.StringFlags;
import facets.util.datatree.ValueNode;
final class ViewerFacet extends FacetCore{
	private final KViewer viewer;
	private final ValueNode areaState;
	private final ViewerAreaMaster vam;
	ViewerFacet(ViewerTarget target,Kit kit,ViewerAreaMaster vam,ValueNode areaState){
		super(target,kit);
		this.vam=vam;
		this.areaState=areaState;
		target.attachFacet(this);
		viewer=kit.masteredViewer(this,vam,target.view(),areaState);
	}
	public void targetNotify(Object msg,boolean interim){
		((KitFacet)((ViewerTarget)target).areaParent().attachedFacet()
				).targetNotify(msg,interim);
	}
	final public void retarget(STarget target,Impact impact){
		if(impact==Notifying.Impact.FLASH)return;
		super.retarget(target,impact);
		if(trace)traceEvent("Refreshing "+Debug.info(base())+" in "+Debug.info(this));
		((KViewer)base()).refresh(impact);
	}
	KWrap lazyBase(){
		return viewer;
	}
	public STarget[]targets(){
		return((Targeted)viewer).targets();
	}
	KWrap[]lazyParts(){
		throw new RuntimeException("Not implemented in "+Debug.info(this));
	}
	SFacet newAreaFacet(SAreaTarget area){
		if(area==null)throw new IllegalArgumentException("Null area in "+Debug.info(this));
		SFrameTarget viewFrame=((ViewerTarget)target()).viewFrame();
		final STargeter viewTargeter=viewFrame.newTargeter();
		viewTargeter.retarget(viewFrame,Impact.DEFAULT);
		return new AreaMountCore(area,kit){
			protected KWrap lazyBase(){
				StringFlags hints=vam.hints();
			  KMount mount=kit.spreadMount(this,hints);
			  mount.setItem(ViewerFacet.this.base());
			  SFacet tools=vam.newViewerTools(viewTargeter);		
			  if(tools!=null)mount.setTools(((KitFacet)tools).base(),hints);
			  return mount;
			}
			protected void retargeted(SAreaTarget area,Impact impact){
				if(false){
					Debug.printStackTrace(10);
					trace(".retargeted: area=",area);
				}
				super.retargeted(area,impact);
				viewTargeter.target().setLive(area.isActive());
				viewTargeter.retargetFacets(impact);
			}
			public void setFacets(SFacet...facets){
				throw new RuntimeException("Not implemented in "+Debug.info(this));
			}
		};
	}
}/*/*
This file forms part of Version 0.8.79 of Facets, a framework demonstrating 
the Superficial approach to GUI-driven interactive applications.  
http://superficial.sourceforge.net 				
Copyright (C) 2011  David M Wright 
This library is free software; you can redistribute it and/or modify it under 
the terms of the GNU Lesser General Public License as published by the 
Free Software Foundation; either release 3 of the License, or (at your 
option) any later release.
This library is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR 
A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more 
details.
You should have received a copy of the GNU Lesser General Public License along 
with this library; if not, write to the Free Software Foundation, Inc., 
59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/
