package facets.facet.app;
import static facets.facet.FacetFactory.*;
import facets.core.app.ActionViewerTarget;
import facets.core.app.AppConstants;
import facets.core.app.DialogSurface;
import facets.core.app.NodeViewable;
import facets.core.app.TreeView;
import facets.core.app.ViewerContenter;
import facets.core.superficial.SFacet;
import facets.core.superficial.SFrameTarget;
import facets.core.superficial.STarget;
import facets.core.superficial.app.SAreaTarget;
import facets.core.superficial.app.SContentRootTargeter;
import facets.core.superficial.app.SHost;
import facets.core.superficial.app.SHost.FacetLayout;
import facets.core.superficial.app.ViewableFrame;
import facets.core.superficial.app.ViewerTarget;
import facets.facet.FacetFactory;
import facets.facet.ViewerAreaMaster;
import facets.util.Debug;
import facets.util.app.AppValues;
import facets.util.datatree.DataNode;
import java.awt.Dimension;
final class AppValuesContenter extends ViewerContenter implements DialogSurface.Contenter{
	private final String title;
	private final FacetFactory ff;
  public AppValuesContenter(String title,FacetAppSurface app){
  	super(app.values);
		this.title=title;
		this.ff=app.ff;
  }
  protected SAreaTarget newViewableContentRoot(Object source, boolean faceted){
  	AppValues values=(AppValues)source;
  	DataNode content=new DataNode("Array",title,
				new Object[]{values.nature(false),values.state()});
  	ViewableFrame viewable=new NodeViewable(content);
  	STarget view=new SFrameTarget(
				new TreeView(title+" View"){				
					public boolean showRoot(){
						return false;
					}
				}
			);
  	ViewerTarget viewer=new ActionViewerTarget(viewable.title(),viewable,view){};
		SAreaTarget panelChild=SAreaTarget.newViewerArea(viewer),
			root=new DialogSurface.ContentRoot(title,new SAreaTarget[]{panelChild},this);
		if(faceted)ff.areas().mount(root,FacetFactory.HINT_PANEL_INSET);
		return root;
	}
	public SFacet newContentPanel(SContentRootTargeter t){
		SAreaTarget root=(SAreaTarget)t.target();
	  return ff.areas().viewerArea((SAreaTarget)root.indexedTarget(),new ViewerAreaMaster(){
			protected String hintString(){return HINT_BARE;}
		});
	}
	public Dimension contentAreaSize(){
		return new Dimension(200,200);
	}
	public void rootRetargeted(SContentRootTargeter t){
		DialogSurface.findDialogTrigger(t,AppConstants.TITLE_APPLY).setLive(false);
	}
	public void applyChanges(){}
	public void reverseChanges(){}
	public String newHostTitle(String surfaceTitle){
		return surfaceTitle+"\n - \n"+AppValues.PATH_DEBUG;
	}
	public String title(){
		return title;
	}
	public void dialogClosed(){}
	public FacetLayout newContentLayout(SHost host,SFacet appRoot,
			SContentRootTargeter t){
		throw new RuntimeException("Not implemented in "+Debug.info(this));
	}
	@Override
	public void setDialog(DialogSurface dialog){}
}/*/*
This file forms part of Version 0.8.79 of Facets, a framework demonstrating 
the Superficial approach to GUI-driven interactive applications.  
http://superficial.sourceforge.net 				
Copyright (C) 2011  David M Wright 
This library is free software; you can redistribute it and/or modify it under 
the terms of the GNU Lesser General Public License as published by the 
Free Software Foundation; either release 3 of the License, or (at your 
option) any later release.
This library is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR 
A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more 
details.
You should have received a copy of the GNU Lesser General Public License along 
with this library; if not, write to the Free Software Foundation, Inc., 
59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/
