package facets.facet.app.tree;
import static facets.util.datatree.Nodes.*;
import facets.core.app.AppConstants;
import facets.core.app.DialogActionDefaults;
import facets.core.app.DialogHost;
import facets.core.app.DialogSurface;
import facets.core.app.DialogSurface.Contenter;
import facets.core.app.DialogSurface.DialogActions;
import facets.core.app.Dialogs.Surfacer;
import facets.core.app.NodeViewable;
import facets.core.superficial.SFacet;
import facets.core.superficial.SIndexing;
import facets.core.superficial.STarget;
import facets.core.superficial.STextual;
import facets.core.superficial.app.SContentRootTargeter;
import facets.core.superficial.app.SSurface;
import facets.facet.FacetFactory;
import facets.facet.FacetFactory.ComboCoupler;
import facets.facet.app.FacetAppSurface;
import facets.facet.app.FacetDialogContenter;
import facets.facet.app.FacetDialogSurface;
import facets.facet.app.FacetDialogContenter.PanelFacets;
import facets.util.datatree.TypedNode;
import facets.util.datatree.ValueNode;
import java.awt.Dimension;
import java.util.ArrayList;
import java.util.Collections;
import java.util.HashSet;
import java.util.Set;
final class TreeTypeChange extends FacetDialogContenter{
	private static final boolean useCombo=false;
	static final String TITLE="Change Type",
		RUBRIC_CHANGE="Change type of selection to:";
	private final FacetAppSurface app;
	private final NodeViewable viewable;
	private final TypedNode selection;
	private final SIndexing types;
	private final STextual type;
	TreeTypeChange(FacetAppSurface app,NodeViewable viewable){
		super(TreeTypeChange.class.getSimpleName()+": "+viewable.title(),app.ff);
		this.app=app;
		selection=(ValueNode)(this.viewable=viewable).selection().selection();
		Set<String>types=new HashSet();
		for(TypedNode each:descendants((TypedNode)viewable.framed))types.add(each.type());
		ArrayList sorter=new ArrayList(types);
		Collections.sort(sorter);
		sorter.add("[New Type]");
		this.types=new SIndexing(RUBRIC_CHANGE,sorter.toArray(),
				selection.type(),
			new ComboCoupler(){
				@Override
				public void indexedTitleEdited(String edit){
					trace(".indexedTitleEdited: edit=",edit);
				}
			});
		type=new STextual(RUBRIC_CHANGE,selection.type(),new STextual.Coupler() {
			@Override
			public boolean updateInterim(STextual t){
				return true;
			}
		});
	}
	@Override
	public void rootRetargeted(SContentRootTargeter t){
		Object type=useCombo?types.indexed():this.type.text();
		DialogSurface.findDialogTrigger(t,AppConstants.TITLE_OK
				).setLive(!type.equals(selection.type()));
	}
	@Override
	protected STarget[]lazyContentRootElements(){
		return useCombo?new STarget[]{types}:new STarget[]{type};
	}
	@Override
	public void applyChanges(){
		selection.setValidType(useCombo?(String)types.indexed():type.text());
	}
	@Override
	public void reverseChanges(){}
	@Override
	public SFacet newContentPanel(SContentRootTargeter t){
		return newPanelFacets(ff).newContentPanel(t);
	}
	@Override
	protected PanelFacets newPanelFacets(FacetFactory core){
		return new PanelFacets(core){
			@Override
			public SFacet newContentPanel(SContentRootTargeter t){
				return rowPanel(t,0,10,HINT_PANEL_INSET+HINT_NONE,
					spacerTall(10),BREAK,
					useCombo?indexingDropdownList(t.elements()[0],HINT_NONE):
						textualField(t.elements()[0],15,HINT_USAGE_FORM),BREAK,
					fill()
				);
			}
		};
	}
	@Override
	public Dimension contentAreaSize(){
		return new Dimension(325,50);
	}
	static void launchDialog(TreeTypeChange tc){
		tc.app.dialogs().launchSurfaced(new Surfacer(){
			@Override
			protected DialogSurface newSurface(SSurface app,DialogHost host,String title,
					DialogActions actions,Contenter[]contents){
				return new FacetDialogSurface((FacetAppSurface)app,host,title,
						actions,contents){
					public boolean isResizable(){
						return false;
					}
				};
			}
		},TITLE,DialogActionDefaults.newOkCancel(),tc);
	}
}/*/*
This file forms part of Version 0.8.79 of Facets, a framework demonstrating 
the Superficial approach to GUI-driven interactive applications.  
http://superficial.sourceforge.net 				
Copyright (C) 2011  David M Wright 
This library is free software; you can redistribute it and/or modify it under 
the terms of the GNU Lesser General Public License as published by the 
Free Software Foundation; either release 3 of the License, or (at your 
option) any later release.
This library is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR 
A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more 
details.
You should have received a copy of the GNU Lesser General Public License along 
with this library; if not, write to the Free Software Foundation, Inc., 
59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/
