package facets.facet.toolkit.avatar;
import facets.core.app.avatar.Painter;
import facets.core.app.avatar.PainterSource;
import facets.util.Debug;
import facets.util.Util;
import facets.util.geom.Line;
import facets.util.geom.Point;
import facets.util.geom.Vector;
import facets.util.shade.Shade;
final class PlaneSnapLine extends Line implements PickPainter,Snappable{
  private final Painter painter;
  private final Shade shade;
  private final byte pattern=true?PainterSource.NO_PATTERN:25;
	private final PlaneCanvas canvas;
  private static Point seekHitPoint(Point from,Point to,Point test,
  		double missGap){
    double left=Math.min(from.x(),to.x())-missGap,
    	right=Math.max(from.x(),to.x())+missGap,
      bottom=Math.min(from.y(),to.y())-missGap,
      top=Math.max(from.y(),to.y())+missGap;
    boolean hit=test.x()>=left&&test.x()<right&&test.y()>=bottom&&test.y()<top;
    if(!hit)return null;
    Point hitAt,midAt=new Point(from.at().mean(to.at()));
    return midAt.distance(from)<missGap?hitAt=midAt
	    :(hitAt=seekHitPoint(from,midAt,test,missGap))!=null?hitAt
	    :seekHitPoint(midAt,to,test,missGap);
  }
  PlaneSnapLine(Line src,Shade shade,PainterSource source,PlaneCanvas canvas){
    super(src.from,src.to);
    this.shade=shade;
    this.canvas=canvas;
    painter=((SwingPainterSource)source).line(src,shade,pattern,false);
  }
  public Object checkCanvasHit(Point canvasAt,double hitGap){
    if(hitGap<0)throw new IllegalArgumentException("hit gap in "+Debug.info(this));
    Point hit=seekHitPoint(from,to,canvasAt,hitGap);if(hit==null)return null;
    double along=hit.distance(from)/length(),
    leapGap=canvas.markLeap();
    Point pickAt=hit.distance(from)<leapGap?from
  		:hit.distance(to)<leapGap?to
  		:new Point(from.at().plus(to.jumpFrom(from).scaled(along)));
    return new Pick(this,pickAt,null);
  }
  public Vector checkSnap(AvatarCanvas canvas,Point check,double snapGap){
  	if(false)Util.println("PlaneSnapLine.checkPointSnap: ",
  			(Util.fx(from.distance(check))));
  	return from.distance(check)<snapGap&&!check.equals(from)?
    	from.jumpFrom(check)
    :to.distance(check)<snapGap&&!check.equals(to)?
    	to.jumpFrom(check)
    :null;
  }
  public void paintInGraphics(Object graphics){
    ((PickPainter)painter).paintInGraphics(graphics);
  }
}
/*/*
This file forms part of Version 0.8.79 of Facets, a framework demonstrating 
the Superficial approach to GUI-driven interactive applications.  
http://superficial.sourceforge.net 				
Copyright (C) 2011  David M Wright 
This library is free software; you can redistribute it and/or modify it under 
the terms of the GNU Lesser General Public License as published by the 
Free Software Foundation; either release 3 of the License, or (at your 
option) any later release.
This library is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR 
A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more 
details.
You should have received a copy of the GNU Lesser General Public License along 
with this library; if not, write to the Free Software Foundation, Inc., 
59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/

