package facets.facet.toolkit.avatar;
import facets.core.app.avatar.PlaneView;
import facets.core.app.avatar.PainterMaster.Rastered;
import facets.util.Util;
import facets.util.geom.Point;

import java.awt.Component;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Image;
import javax.swing.ImageIcon;
final class SwingPainterRastered implements PickPainter{
	private final Component swing;
	private final Image master;
	private final PlaneCanvas plane;
	private Image imagePaint;
	private int widthPane,heightPane,shiftY,shiftX;
	SwingPainterRastered(Rastered master,PlaneCanvas plane,Component swing){
		this.plane=plane;
		this.swing=swing;
		this.master=new ImageIcon(master.url).getImage();
	}
	public void paintInGraphics(Object graphics){
		if(plane.paneWidth!=widthPane||plane.paneHeight!=heightPane){
			widthPane=plane.paneWidth;heightPane=plane.paneHeight;
			rescalePaintImage();
		}
		((Graphics)graphics).drawImage(imagePaint,shiftX,shiftY,null);
	}
	private void rescalePaintImage(){
		PlaneView view=(PlaneView)plane.viewer().view();
		double widthImage=master.getWidth(null),heightImage=master.getHeight(null),
			widthPaint=plane.scale(view.showWidth()),
			heightPaint=plane.scale(view.showHeight());
		imagePaint=swing.createImage((int)widthPaint,(int)heightPaint);
		Graphics2D gi=(Graphics2D)imagePaint.getGraphics();
		gi.scale(widthPaint/widthImage,heightPaint/heightImage);
		gi.drawImage(master,0,0,null);gi.dispose();
		shiftY=(int)(heightPane>heightPaint?(heightPane-heightPaint)/2:0);
		shiftX=(int)(widthPane>widthPaint?(widthPane-widthPaint)/2:0);
	}
	public Object checkCanvasHit(Point canvasAt,double hitGap){
		return null;		
	}
}/*/*
This file forms part of Version 0.8.79 of Facets, a framework demonstrating 
the Superficial approach to GUI-driven interactive applications.  
http://superficial.sourceforge.net 				
Copyright (C) 2011  David M Wright 
This library is free software; you can redistribute it and/or modify it under 
the terms of the GNU Lesser General Public License as published by the 
Free Software Foundation; either release 3 of the License, or (at your 
option) any later release.
This library is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR 
A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more 
details.
You should have received a copy of the GNU Lesser General Public License along 
with this library; if not, write to the Free Software Foundation, Inc., 
59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/
