package facets.facet.toolkit.swing;
import static facets.facet.AreaFacets.*;
import facets.core.app.ActionAppSurface;
import facets.core.app.AppActions;
import facets.core.app.AppConstants;
import facets.core.superficial.STarget;
import facets.core.superficial.SToggling;
import facets.core.superficial.STrigger;
import facets.core.superficial.app.SAreaTarget;
import facets.facet.toolkit.KWrap;
import facets.facet.toolkit.Kit;
import facets.facet.toolkit.KitFacet;
import facets.facet.toolkit.swing.AppDesktop.ContentPanel;
import facets.util.app.AppValues;
import facets.util.datatree.ValueNode;
import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Component;
import java.util.ArrayList;
import java.util.List;
import javax.swing.Icon;
import javax.swing.JPanel;
final class AppMount extends MountCore implements STarget.Targeted{
	private final class DesktopPanel extends ContentPanel{
		final KitFacet facet;
		DesktopPanel(KWrap wrap){
			facet=wrap.facet();
			setLayout(new BorderLayout());
	    add((Component)wrap.wrapped(),BorderLayout.CENTER);
		}
		protected String windowTitle(){
			return facet.title();
		}
		public boolean windowCanClose(){
			if(false)((SAreaTarget)facet.target()).ensureActive(false);
			return actions.windowTryClose();
		}
		protected void windowMaximumSet(boolean onOff){
			areaValues.put(KEY_DESKTOP_MAXIMUM,onOff);
		}
		protected void windowActivated(){
			if(false)traceDebug(".windowActivated: facet=",facet);
			((SAreaTarget)facet.target()).ensureActive(true);
		}
		@Override
		protected Icon windowIcon(){
			return (Icon)kit.getDecorationIcon(AppConstants.NATURE_APP_ICON_INTERNAL, false);
		}
	}
	private final STrigger desktopTile=new STrigger(TITLE_DESKTOP_TILE,
			new STrigger.Coupler(){
		public void fired(STrigger t){
			desktop.tileWindows();
		}
	});
	private final SToggling deskTopScale=new SToggling(TITLE_DESKTOP_SCALE,true,
			new SToggling.Coupler(){
		public void stateSet(SToggling t){
			boolean on=t.isSet();
			if(swing!=null)desktop.setScaleToDesktop(on);
			areaValues.put(KEY_DESKTOP_NO_SCALE,!on);
		}
	});
  public STarget[]targets(){
	  return getMount()instanceof AppTabs?new STarget[]{}
			:new STarget[]{desktopTile,deskTopScale};
	}
	private final Kit kit;
	private final ValueNode areaValues;
	private final AppActions actions;
	private AppDesktop desktop;
	AppMount(ActionAppSurface app,Kit kit,KitFacet facet,boolean asDesktop){
		super(facet,null);
		Kit.widgets++;
		this.kit=kit;
		actions=app.actions;
		areaValues=app.values.state(AppValues.PATH_CORE,STATE_NODE_AREA);
		deskTopScale.set(!areaValues.getBoolean(KEY_DESKTOP_NO_SCALE));
		setSwing(new JPanel(new BorderLayout()));
    swing.add(asDesktop?(desktop=new AppDesktop(new Color(COLOR_DESKTOP.rgb()),
					areaValues.getBoolean(KEY_DESKTOP_MAXIMUM),deskTopScale.isSet()
				)).getPanel()
			:new AppTabs(kit,actions),
		BorderLayout.CENTER);
  }
	public void setItems(KWrap... items){
		Component mount=getMount();
	  if(mount instanceof AppTabs){
	    AppTabs tabs=(AppTabs)mount;
	    tabs.removeAll();
	    for(int i=0;i<items.length;i++)tabs.addItem(items,i);
	  }
	  else{
	  	List<ContentPanel>nowContents=new ArrayList();
	  	for(KWrap item:items){
	  		ContentPanel addContent=null;
	  		for(ContentPanel thenContent:desktop.getContents())
	  			if(((DesktopPanel)thenContent).facet==item.facet())
	  				nowContents.add(addContent=thenContent);
	  		if(addContent==null)nowContents.add(new DesktopPanel(item));
		  }
			desktop.setContents(nowContents);
			desktopTile.setLive(nowContents.size()>1);
	  }
	}
	public void setActiveItem(KWrap item){
	  Component base=getMount();
	  if(base instanceof AppTabs)
	    ((AppTabs)base).setSelectedComponent(swingWrapped(item));
		else for(ContentPanel content:desktop.getContents())
			if(((DesktopPanel)content).facet==item.facet())
				desktop.setActiveContent(content);
	}
	private Component getMount(){
		return swing.getComponent(0);
	}
}
/*/*
This file forms part of Version 0.8.79 of Facets, a framework demonstrating 
the Superficial approach to GUI-driven interactive applications.  
http://superficial.sourceforge.net 				
Copyright (C) 2011  David M Wright 
This library is free software; you can redistribute it and/or modify it under 
the terms of the GNU Lesser General Public License as published by the 
Free Software Foundation; either release 3 of the License, or (at your 
option) any later release.
This library is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR 
A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more 
details.
You should have received a copy of the GNU Lesser General Public License along 
with this library; if not, write to the Free Software Foundation, Inc., 
59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/

