package facets.facet.toolkit.swing;
import static facets.facet.FacetFactory.*;
import facets.core.app.AppActions;
import facets.facet.app.FacetAppActions;
import facets.facet.app.FacetAppSurface;
import facets.facet.toolkit.KWrap;
import facets.facet.toolkit.Kit;
import facets.util.Debug;
import facets.util.StringFlags;
import facets.util.Util;
import java.awt.Color;
import java.awt.Component;
import java.awt.FlowLayout;
import java.awt.Font;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.RenderingHints;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import javax.swing.Icon;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTabbedPane;
import javax.swing.SwingConstants;
final class AppTabs extends JTabbedPane{
	private final Kit kit;
	private final AppActions appActions;
	private final class Tab extends JPanel{
		private final MouseListener mouseListener=new MouseAdapter(){
			public void mouseEntered(MouseEvent e){
				close.setIcon(e.getSource()==close?closeIconHi:closeIconLo);
			}
			public void mouseExited(MouseEvent e){
				close.setIcon(blankIcon);
			}
			public void mouseClicked(MouseEvent e){
				AppTabs.this.setSelectedComponent((Component)item.wrapped());
	      item.facet().targetNotify(item,false);
				if(e.getSource()==close)appActions.windowTryClose();
			}
		};
		private final KWrap item;
		private final JLabel caption,close;
		private final Icon blankIcon,closeIconLo,closeIconHi;
		Tab(KWrap[]items,int at){
			super(new FlowLayout(0,0,0));
			item=items[at];
			AppTabs.this.addTab(null,(Component)item.wrapped());
			AppTabs.this.setTabComponentAt(at,this);
			setOpaque(false);
			addMouseListener(mouseListener);
			caption=new JLabel(Debug.info(this),0);
			KitSwing.adjustFont(caption);
			add(caption);
			add(new JLabel(""));
			blankIcon=newTabIcon(kit,"");
			closeIconLo=newTabIcon(kit,KEY_TAB_CLOSE_LO);
			closeIconHi=newTabIcon(kit,KEY_TAB_CLOSE_HI);
			close=new JLabel(blankIcon,0);
			if(items.length==1)return;
			add(close);
			caption.addMouseListener(mouseListener);
			close.addMouseListener(mouseListener);
			close.setToolTipText(kit.getDecorationTitle(KEY_TAB_CLOSE_LO));
			update();
		}
		void update(){
			String title=item.facet().title();
			caption.setText(kit.decoration(title,StringFlags.EMPTY).tabCaption());
			caption.setIcon((Icon)kit.getDecorationIcon(title.replace("([^.]+).*","$1"), false));
			caption.setToolTipText(title.replaceAll("([^:]+).*","$1"));
		}
	}
	private static Icon newTabIcon(Kit kit,final String key){
		Icon got=(Icon)kit.getDecorationIcon(key, false);
		return got!=null?got:new Icon(){
			public int getIconHeight(){
				return 14;
			}
			public int getIconWidth(){
				return 14;
			}
			public void paintIcon(Component c,Graphics g,int x,int y){
				if(key.equals(""))return;
				Graphics2D g2=(Graphics2D)g.create();
				g2.setRenderingHint(RenderingHints.KEY_ANTIALIASING,
				    RenderingHints.VALUE_ANTIALIAS_ON);
				g2.setFont(new Font("SansSerif",Font.BOLD,12));
				g2.setColor(key.equals(KEY_TAB_CLOSE_LO)?Color.LIGHT_GRAY:Color.RED);
				g2.drawString("X",x+5,y+12);
			}
		};
	}
	AppTabs(Kit kit,AppActions appActions){
		super(SwingConstants.TOP);
		this.kit=kit;
		this.appActions=appActions;
}
	void addItem(KWrap[]items,int at){
		new Tab(items,at);
	}
	public void setSelectedComponent(Component c){
		super.setSelectedComponent(c);
		((Tab)getTabComponentAt(indexOfComponent(c))).update();
	}
}/*/*
This file forms part of Version 0.8.79 of Facets, a framework demonstrating 
the Superficial approach to GUI-driven interactive applications.  
http://superficial.sourceforge.net 				
Copyright (C) 2011  David M Wright 
This library is free software; you can redistribute it and/or modify it under 
the terms of the GNU Lesser General Public License as published by the 
Free Software Foundation; either release 3 of the License, or (at your 
option) any later release.
This library is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR 
A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more 
details.
You should have received a copy of the GNU Lesser General Public License along 
with this library; if not, write to the Free Software Foundation, Inc., 
59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/
