package facets.facet.toolkit.swing;
import static facets.facet.app.FacetAppActions.*;
import static java.awt.Cursor.*;
import static javax.swing.SwingUtilities.*;
import facets.facet.app.FacetAppActions;
import facets.util.app.WatchableOperation;
import facets.util.app.AppWatcher;
import java.awt.AWTEvent;
import java.awt.Container;
import java.awt.EventQueue;
import java.awt.Toolkit;
import java.awt.event.InputEvent;
import java.awt.event.KeyEvent;
import java.util.EmptyStackException;
import javax.swing.JDialog;
import javax.swing.JOptionPane;
import javax.swing.SwingUtilities;
final class AppWatcherSwing extends AppWatcher{
	private final Toolkit swingKit=Toolkit.getDefaultToolkit();
	private final EventQueue system=swingKit.getSystemEventQueue();
	private final class FutureQueue extends EventQueue{
		protected void pop()throws EmptyStackException{
			super.pop();
		}
		@Override
		protected void dispatchEvent(AWTEvent e){
			if(false)trace(".dispatchEvent: e=",e);
			if(e instanceof KeyEvent&&((KeyEvent)e).getKeyCode()==27)
				futureRunning(false);
			else if(!(e instanceof InputEvent))super.dispatchEvent(e);
		};
	}
	private EventQueue active=system;
	private JDialog dialog;
	private AWTEvent eventThen;
	Container blockParent;
	AppWatcherSwing(boolean inApplet){
		super(inApplet);
	}
	@Override
	protected boolean checkBusy(){
		if(active==null)return false;
		AWTEvent event=active.peekEvent();
		boolean sameEvent=event==eventThen,busy=event!=null&&sameEvent;
		eventThen=event;
		invokeLater(new Runnable(){public void run(){}});
		return busy;
	}
	@Override
	protected void openBlockingDialog(WatchableOperation op){
		String[]texts=op.getBlockingCancelTexts();
		JOptionPane pane=new JOptionPane("<html>"+texts[BLOCKING_RUBRIC_1],
				JOptionPane.INFORMATION_MESSAGE);
		pane.setOptions(new Object[]{"Cancel"});
		dialog=pane.createDialog(blockParent,texts[BLOCKING_TITLE_0]);
		dialog.setLocation(blockParent.getBounds().getLocation());
		if(blocking==null)return;
		trace(".openBlockingDialog: op=",op);
		dialog.setCursor(getPredefinedCursor(WAIT_CURSOR));
		dialog.setVisible(true);
		trace(".~openBlockingDialog: cancellable=",blocking);
	}
	@Override
	protected void cancelBlockingDialog(){
		Runnable cancel=new Runnable(){public void run(){
			if(dialog!=null)dialog.setVisible(false);
		}};
		if(false)cancel.run();
		SwingUtilities.invokeLater(cancel);
	}
	@Override
	protected void scheduleFuture(final WatchableOperation op){
		SwingUtilities.invokeLater(new Runnable(){public void run(){
			runFuture(op);
		}});
	}
	@Override
	protected void futureRunning(boolean on){
		traceDebug(".futureRunning: on=" +on+" ",this);
		if(on)system.push(active=new FutureQueue());
		else{
			((FutureQueue)active).pop();
			active=system;
		}
	}
}/*/*
This file forms part of Version 0.8.79 of Facets, a framework demonstrating 
the Superficial approach to GUI-driven interactive applications.  
http://superficial.sourceforge.net 				
Copyright (C) 2011  David M Wright 
This library is free software; you can redistribute it and/or modify it under 
the terms of the GNU Lesser General Public License as published by the 
Free Software Foundation; either release 3 of the License, or (at your 
option) any later release.
This library is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR 
A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more 
details.
You should have received a copy of the GNU Lesser General Public License along 
with this library; if not, write to the Free Software Foundation, Inc., 
59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/
