package facets.facet.toolkit.swing;
import static facets.core.app.AppActions.*;
import static facets.facet.AreaFacets.*;
import static facets.facet.app.FacetAppActions.*;
import static facets.util.app.AppValues.*;
import static javax.swing.BorderFactory.*;
import facets.core.app.ActionAppSurface;
import facets.core.app.AppHost;
import facets.core.app.Dialogs;
import facets.core.app.SurfaceServices;
import facets.core.superficial.SFacet;
import facets.core.superficial.SNumeric;
import facets.core.superficial.SNumeric.Coupler;
import facets.core.superficial.app.SHost;
import facets.core.superficial.app.SSurface;
import facets.facet.FacetFactory;
import facets.facet.FacetFactory.AppletHost;
import facets.facet.FacetFactory.SurfaceStyle;
import facets.facet.toolkit.KMount;
import facets.facet.toolkit.KWrap;
import facets.facet.toolkit.Kit;
import facets.facet.toolkit.KitFacet;
import facets.util.Debug;
import facets.util.NumberPolicy;
import facets.util.Tracer;
import facets.util.app.BusyCursor;
import facets.util.datatree.ValueNode;
import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Component;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.LayoutManager;
import java.awt.Rectangle;
import javax.swing.JApplet;
import javax.swing.JComponent;
import javax.swing.JLayeredPane;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JPanel;
import javax.swing.SwingUtilities;
import javax.swing.border.Border;
import javax.swing.border.CompoundBorder;
import javax.swing.border.MatteBorder;
final class HostWrap extends Tracer implements AppHost,AppletHost{
	private static final CompoundBorder TOOLS_BORDER=new CompoundBorder(
			new MatteBorder(0,0,1,0,Color.GRAY),createEmptyBorder(2,2,2,2));
	private final class Layout implements SHost.FacetLayout{
		private final JMenu[]menus;
		private final KWrap content,extras;
		private final JComponent toolbar,sidebar,status;
	  private final SurfaceServices services;
	  private final Component toolbarParts[],statusParts[];
		private boolean hideToolbar,hideSidebar,hideStatus;
		Layout(SFacet content,SFacet[]menus,SFacet toolbar,
				SFacet sidebar,SFacet status,SurfaceServices services,
				boolean toolsToSide,SFacet extras){
			this.content=((KitFacet)content).base();
			this.extras=extras==null?null:((KitFacet)extras).base();
			this.menus=menus==null?null:new JMenu[menus.length];
			if(menus!=null)for(int i=0;i<this.menus.length;i++)
				this.menus[i]=(JMenu)facetBaseWrapped(menus[i]);
			this.sidebar=sidebar==null?null:facetBaseWrapped(sidebar);	
			if(sidebar!=null)this.sidebar.setFont(swingMenus.getFont());
			this.status=status==null?null:facetBaseWrapped(status);
			statusParts=status==null?null:this.status.getComponents();
			this.toolbar=toolbar==null?null:facetBaseWrapped(toolbar);
			toolbarParts=toolbar==null?null:this.toolbar.getComponents();
			this.services=services;
			if(appletStyle){
				Object toolsAt=toolsToSide?BorderLayout.EAST:BorderLayout.SOUTH,
					mainAt=toolsToSide?BorderLayout.WEST:BorderLayout.NORTH;
				swingBase.setLayout(new ToolsLayout(toolsAt));
				swingBase.add(swingContent,mainAt);
				swingBase.add(swingAppletTools,toolsAt);
			}
		}
		void setSwingContents(){
			if(swingMenus!=null) {
				swingMenus.removeAll();
				boolean normalMenubarPosition=swingMenus.getParent()instanceof JLayeredPane;
				if(FacetFactory.surfaceStyle==SurfaceStyle.BROWSER&&!normalMenubarPosition)
					((JApplet)SwingUtilities.getAncestorOfClass(JApplet.class,swingMenus)
							).setJMenuBar(null);
				if(menus!=null){
				  for(int i=0;i<menus.length;i++){
				  	if(false&&!normalMenubarPosition)menus[i].getComponent(
				  			).setBackground(new Color(0xeeeeff));
				  	if(menus[i]!=null)swingMenus.add(menus[i]);
				  }
				  swingMenus.validate();
				  swingMenus.repaint();
			  }
			}
			if(appletStyle&&toolbar!=null)swingAppletTools.add(toolbar);
			else{
				swingToolbar.setHidden(true);
				swingSidebar.setHidden(true);
				swingStatus.setHidden(true);
				if(toolbar!=null&&!hideToolbar){
					swingToolbar.setHidden(false);
					if(toolbarParts.length==0)throw new IllegalStateException(
							"Empty toolbar in "+Debug.info(this));
					swingToolbar.setParts(toolbarParts);
				}
				if(sidebar!=null&&!hideSidebar){
					if(sidebar.getComponentCount()==0)throw new IllegalStateException(
							"Empty sidebar in "+Debug.info(this));
					swingSidebar.setHidden(false);
					swingSidebar.setParts(new Component[]{sidebar});
				}
				if(status!=null&&!hideStatus){
					if(statusParts.length==0)throw new IllegalStateException(
							"Empty status in "+Debug.info(this));
					swingStatus.setHidden(false);
					swingStatus.setParts(statusParts);
				}
			}
		  swingContent.removeAll();
			swingContent.add((Component)content.wrapped(),BorderLayout.CENTER);
			swingBase.validate();
		}
		void setHideToolbar(boolean hide){
			if(hideToolbar==hide)return;
			swingToolbar.setHidden(hideToolbar=hide);
			if(!hide)swingToolbar.setParts(toolbarParts);
		}
		void setHideSidebar(boolean hide){
			if(hideSidebar==hide)return;
			swingSidebar.setHidden(hideSidebar=hide);
			if(!hide)swingSidebar.setParts(sidebar);
		}
		void setHideStatus(boolean hide){
			if(hideStatus==hide)return;
			swingStatus.setHidden(hideStatus=hide);
			if(!hide)swingStatus.setParts(statusParts);
		}
		void adjustForExtras(final ValueNode app){
			if(extras==null)return;
		  KWrap adjusted=null;
		  if(app.getBoolean(KEY_SHOW_EXTRAS)){
				final String keySplit=KEY_EXTRAS_SPLIT;
				KMount split=kit.splitMount(FacetFactory.NO_FACET,true,
					new SNumeric("Extras",app.getOrPutDouble(keySplit,30),new Coupler(){
					public NumberPolicy policy(SNumeric n){
						return SASH_SPLIT_POLICY;
					}
					public void valueSet(SNumeric n){
						app.put(keySplit,(int)n.value());
					}
				}));
				split.setItems(extras,content);
				adjusted=split;
		  }
		  else adjusted=content;
			swingContent.removeAll();
			swingContent.add((Component)adjusted.wrapped(),BorderLayout.CENTER);
		}
		private JComponent facetBaseWrapped(SFacet facet){
			return(JComponent)((KitFacet)facet).base().wrapped();
		}
	}
	public void updateLayout(SSurface surface){
		if(active==null)throw new IllegalStateException("Null layout in "+Debug.info(this));
		final ValueNode state=((ActionAppSurface)surface).values.state(PATH_CORE_APP);
		active.setHideToolbar(state.getBoolean(KEY_HIDE_TOOLBAR));
		active.setHideSidebar(state.getBoolean(KEY_HIDE_SIDEBAR));
		active.setHideStatus(state.getBoolean(KEY_HIDE_STATUS));
		active.adjustForExtras(state);
		swingBase.validate();
	}
	private abstract class HidePanel extends JPanel{
		private final Border border;
		private final LayoutManager layout;
		private boolean hide;
		HidePanel(Border border,LayoutManager layout){
			setBorder(this.border=border);
			setLayout(this.layout=layout);
			if(false)setBackground(Color.RED);
		}
		final public void setHidden(boolean on){
			hide=on;
			if(on){
				removeAll();
				setBorder(null);
				setLayout(null);
			}
			else{
				setBorder(border);
				setLayout(layout);
			}
		}
		protected abstract void setParts(Component...parts);
		final public Dimension getPreferredSize(){
			return hide?new Dimension(0,0):super.getPreferredSize();
		}
	}
	private final HidePanel swingToolbar=new HidePanel(TOOLS_BORDER,null){		
			protected void setParts(Component... parts){
				KitSwing.addToolGroups(this,parts);
			}
		},
		swingSidebar=new HidePanel(true?null:createEtchedBorder(),
				new FlowLayout(FlowLayout.LEFT,5,3)){
			protected void setParts(Component... parts){
				add(parts[0]);
			}				
		},
		swingStatus=new HidePanel(createLoweredBevelBorder(),
				new FlowLayout(FlowLayout.LEFT,3,3)) {
			protected void setParts(Component... parts){
				for(int i=0;i<parts.length;i++)add(parts[i]);
			}		
		};
	private final Container swingBase=new JPanel(),
		swingContent=new JPanel(new BorderLayout()),
		swingAppletTools=new JPanel();
	private final KitSwing kit;
	private final JMenuBar swingMenus;
	private final boolean appletStyle;
	private final BusyCursor cursor;
	private Layout active;
  HostWrap(KitSwing kit,JMenuBar swingMenus){
  	this.kit=kit;
		this.swingMenus=swingMenus;
  	kit.watcher.pushCursor(cursor=kit.newBusyCursor(swingBase,swingMenus));
  	appletStyle=FacetFactory.surfaceStyle!=SurfaceStyle.DESKTOP;
		if(appletStyle){
			if(swingMenus!=null)swingMenus.setBorderPainted(false);
			if(FacetFactory.surfaceStyle==SurfaceStyle.BROWSER){
	  		Color panelColor=new Color(FacetFactory.panelShade.rgb());
	  		swingBase.setBackground(panelColor);
	  		if(swingMenus!=null)swingMenus.setBackground(panelColor);
	  		swingContent.setBackground(panelColor);
	  		swingAppletTools.setBackground(panelColor);
			}
		}else{
			Object toolsAt=BorderLayout.NORTH,restAt=BorderLayout.SOUTH;
	    swingBase.setLayout(new ToolsLayout(toolsAt));
			swingBase.add(swingToolbar,toolsAt);
			JPanel rest=new JPanel(new GridBagLayout(){{
				columnWeights=new double[]{1,0};
				rowWeights=new double[]{1,0};
			}});
			swingBase.add(rest,restAt);
			rest.add(swingContent,new GridBagConstraints(){{
				gridx=0;fill=BOTH;
			}});
			rest.add(swingSidebar,new GridBagConstraints(){{
				gridx=1;anchor=NORTHWEST;fill=BOTH;
			}});
			rest.add(swingStatus,new GridBagConstraints(){{
				gridx=0;gridy=1;gridwidth=2;
				anchor=WEST;fill=BOTH;
			}});
		}
		Kit.widgets+=5;
	}
	public Object wrapped(){
		return swingBase;
	}
	public FacetLayout newDesktopLayout(SFacet contentFacet, LayoutFeatures f){
		Layout layout=new Layout(contentFacet,f.menus(),f.toolbar(),f.sidebar(),f.status(),
				f.services(),false,f.extras());
		return layout;
	}
  public FacetLayout newAppletLayout(SFacet content,SFacet toolPanel,
  		SFacet[]menus,boolean panelToSide){
		return new Layout(content,menus,toolPanel,null,null,null,panelToSide,null);
	}
	public void setLayout(FacetLayout layout){
		if(layout==FacetLayout.HEADLESS)return;
		cursor.forceSwitch(false);
		(this.active=(Layout)layout).setSwingContents();
		Runnable forceSwitch=new Runnable(){public void run(){
			cursor.forceSwitch(true);
		}};
		if(false)SwingUtilities.invokeLater(forceSwitch);
		else forceSwitch.run();
	}
	public SurfaceServices activeServices(){
		SurfaceServices services=active.services;
		if(false&&services==null)throw new IllegalStateException("No services set in "+Debug.info(active));
		return services;
	}
	public String toString(){
		return super.toString()+(true?""
				:":{\n"+Debug.info(swingContent.getComponent(0))
		+"\n"+Debug.info(swingMenus.getComponent(0))
		+"\n"+Debug.info(swingToolbar.getComponent(0))
		+"\n}");
	}
	public void setTitle(String title){}
	public Dimension screenSize(){
		return swingBase.getToolkit().getScreenSize();
	}
	public Rectangle windowBounds(){
		Dimension screen = screenSize();
		int width=swingBase.getWidth(),height=swingBase.getHeight(),
			x=(screen.width-width)/2,y=(screen.height-height)/2;
		return new Rectangle(x,y,width,height);
	}
	public Dialogs newDialogs(ActionAppSurface app){
		throw new RuntimeException("Not implemented in "+Debug.info(this));
	}
	public void runHostedApp(){
		throw new RuntimeException("Not implemented in "+Debug.info(this));
	}
	public void splashDown(){
		throw new RuntimeException("Not implemented in "+Debug.info(this));
	}
	public void splashUp(String msg){
		throw new RuntimeException("Not implemented in "+Debug.info(this));
	}
}/*/*
This file forms part of Version 0.8.79 of Facets, a framework demonstrating 
the Superficial approach to GUI-driven interactive applications.  
http://superficial.sourceforge.net 				
Copyright (C) 2011  David M Wright 
This library is free software; you can redistribute it and/or modify it under 
the terms of the GNU Lesser General Public License as published by the 
Free Software Foundation; either release 3 of the License, or (at your 
option) any later release.
This library is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR 
A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more 
details.
You should have received a copy of the GNU Lesser General Public License along 
with this library; if not, write to the Free Software Foundation, Inc., 
59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/
