package facets.facet.toolkit.swing;
import static java.lang.Math.*;
import facets.core.app.HtmlContent.HtmlSelected;
import facets.idiom.IdiomApplet;
import facets.util.Debug;
import facets.util.TextLines;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.GridLayout;
import java.io.ByteArrayInputStream;
import java.io.File;
import java.io.IOException;
import java.io.InputStream;
import java.util.Collections;
import java.util.HashMap;
import java.util.Map;
import javax.swing.JEditorPane;
import javax.swing.JPanel;
import javax.swing.JTextField;
import javax.swing.event.CaretEvent;
import javax.swing.event.CaretListener;
import javax.swing.text.AttributeSet;
import javax.swing.text.BadLocationException;
import javax.swing.text.Document;
import javax.swing.text.EditorKit;
import javax.swing.text.Element;
import javax.swing.text.MutableAttributeSet;
import javax.swing.text.PlainDocument;
import javax.swing.text.StyleConstants;
import javax.swing.text.StyledEditorKit;
import javax.swing.text.View;
import javax.swing.text.ViewFactory;
import javax.swing.text.html.HTML.Tag;
import javax.swing.text.html.HTMLEditorKit;
import javax.swing.text.html.HTMLEditorKit.ParserCallback;
import javax.swing.text.html.ObjectView;
final class HtmlSelectingDocument extends HtmlTracingDocument{
	private static final String SOURCE_AT="sourceAt";
	HtmlSelected newSourceSelected(int renderStart,int renderStop){
		HtmlSelected selected=new HtmlSelected(renderStart,renderStop,-1,-1){
			@Override
			public boolean fontIsBold(){
				boolean isSo=true;
				for(int pos=renderStart;pos<renderStop+(renderStart==renderStop?1:0);pos++)
					isSo&=StyleConstants.isBold((AttributeSet)getCharacterElement(pos));
				return isSo;
			}
			@Override
			public boolean fontIsItalic(){
				boolean isSo=true;
				for(int pos=renderStart;pos<renderStop+(renderStart==renderStop?1:0);pos++)
					isSo&=StyleConstants.isItalic((AttributeSet)getCharacterElement(pos));
				return isSo;
			}
		};
		if(true)return selected;
		else if(true)throw new RuntimeException("Not implemented in "+Debug.info(this));
		Element charsFirst=getCharacterElement(renderStart),
			charsLast=getCharacterElement(renderStop);
		String source=source();
		int charsSourceAt=(Integer)charsFirst.getAttributes().getAttribute(SOURCE_AT),
			charsFirstAt=charsFirst.getStartOffset(),
			startAt=charsSourceAt+renderStart-charsFirstAt+1,
			stopAt=(Integer)charsLast.getAttributes().getAttribute(SOURCE_AT)+
				renderStop-charsLast.getStartOffset()+1,
			lastCloseAt=source.substring(0,charsSourceAt).lastIndexOf("</"),
			lastTagAt=source.substring(0,charsSourceAt).lastIndexOf("<");
		if(charsFirstAt==renderStart&&lastTagAt>lastCloseAt){
			String fromLastClose=source.substring(lastCloseAt<0?charsSourceAt:lastCloseAt,
					charsSourceAt);
			startAt-=(fromLastClose.length()-fromLastClose.indexOf("<",1)+1);
		}
		return null;
	}
	final Document code=new PlainDocument();
	@Override
	public ParserCallback getReader(int pos){
		return new HTMLReader(pos){
			int sourceAt;
			@Override
			public void handleStartTag(Tag t,MutableAttributeSet atts,int pos){
				if(true||!t.isBlock())storeSourceAt(pos,t+">");
				super.handleStartTag(t,atts,pos);
			}
			@Override
			public void handleEndTag(Tag t,int pos){
				super.handleEndTag(t,pos);
				if(true||!t.isBlock())storeSourceAt(pos,"/"+t+">");
			}
			private void storeSourceAt(int pos,String tagText){
				if(true||tagText.contains("/"))pos+=tagText.length();
				charAttr.addAttribute(SOURCE_AT,pos);
				if(false)trace(":" +pos+"="+source().substring(pos).trim());
			}
		};
	}
	@Override
	protected void traceOutput(String msg){
		if(true)super.traceOutput(msg);
	}
	@Override
	protected Element createLeafElement(Element parent,AttributeSet a,int p0,
			int p1){
		Integer pos=(Integer)a.getAttribute(SOURCE_AT);
		try{
			String text=getText(p0,p1-p0).trim();
			if(false&&!text.equals(""))trace(":" +pos+"="+source().substring(pos).trim());
		}catch(BadLocationException e){
			throw new RuntimeException(e);
		}
		return super.createLeafElement(parent,a,p0,p1);
	}
	void readBoth(EditorKit codeKit,EditorKit renderKit,InputStream stream)throws IOException,
			BadLocationException{
		codeKit.read(stream,code,0);
		renderKit.read(new ByteArrayInputStream(source().getBytes()),this,0);
	}
	final static class PaneTest extends IdiomApplet{
		final JEditorPane code=new JEditorPane(),render=new JEditorPane();
		final JPanel panel=new JPanel(new GridLayout(2,1,10,10));
		private final TextLines lines;
		PaneTest(TextLines lines,String[]args){
			super(args);
			this.lines=lines;
			render.setEditorKit(new HTMLEditorKit(){
				@Override
				public ViewFactory getViewFactory(){
					return new HTMLFactory(){
						@Override
						public View create(Element elem){
							trace(".create: elem="+elem.toString().trim());
							if(!elem.getName().equals("object"))return super.create(elem);
							return new ObjectView(elem){
								@Override
								protected Component createComponent(){
									Element element=getElement();
									if(false)trace(".create: atts=",attributeMap(element).toString().split(","));
									return new JTextField("Hi I'm a field");
								}
								@Override
								public float getPreferredSpan(int axis){
									return axis==View.X_AXIS?100f:20f;
								}
								@Override
								public float getMaximumSpan(int axis){
									return getPreferredSpan(axis);
								}
							};
						}
					};
				}
			});
			panel.setPreferredSize(new Dimension(400,150));
			panel.add(render);
			panel.add(code);
			render.setDragEnabled(true);
			code.setEditable(true);
			code.setDragEnabled(true);
		}
		protected Component newDialogMessagePanel()throws Exception{
			final HtmlSelectingDocument doc=new HtmlSelectingDocument();
			doc.readBoth(code.getEditorKit(),render.getEditorKit(),lines.newInputStream());
			if(false)render.setEditorKit(new StyledEditorKit());
			render.setDocument(doc);
			code.setDocument(doc.code);
			code.selectAll();
			render.addCaretListener(new CaretListener(){
				@Override
				public void caretUpdate(CaretEvent e){
					int dot=e.getDot(),mark=e.getMark(),
						paneStart=min(mark,dot),paneStop=max(mark,dot);
					HtmlSelected runs=doc.newSourceSelected(paneStart,paneStop);
					if(false)trace(".caretUpdate: fontIsItalic="+runs.fontIsItalic()+
							" fontIsBold="+runs.fontIsBold());
					if(true)return;
					code.select(runs.codeStart,runs.codeStop);
					code.requestFocus();
				}
			});
			return panel;
		}
	}
	public static void main(String[]args)throws Exception{
		TextLines.setDefaultEncoding(true);
		TextLines lines=new TextLines(new File("HtmlSelected.html"));
		if(true)lines=TextLines.newBuffer(new String[]{lines.readLinesString(
				).replaceAll("(?s)\\s"," ")});
		new PaneTest(lines,args).buildAndLaunch(false);
	}
	protected static Map attributeMap(Element elem){
		Map map=new HashMap();
		AttributeSet attributes=elem.getAttributes();
		for(Object name:Collections.list(attributes.getAttributeNames()))
			map.put(name,attributes.getAttribute(name));
		return map;
	}
	public String source(){
		try{
			return code.getText(0,code.getLength());
		}catch(BadLocationException e){
			throw new RuntimeException(e);
		}
	}
}/*/*
This file forms part of Version 0.8.79 of Facets, a framework demonstrating 
the Superficial approach to GUI-driven interactive applications.  
http://superficial.sourceforge.net 				
Copyright (C) 2011  David M Wright 
This library is free software; you can redistribute it and/or modify it under 
the terms of the GNU Lesser General Public License as published by the 
Free Software Foundation; either release 3 of the License, or (at your 
option) any later release.
This library is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR 
A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more 
details.
You should have received a copy of the GNU Lesser General Public License along 
with this library; if not, write to the Free Software Foundation, Inc., 
59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/
