package facets.facet.toolkit.swing;
import static facets.facet.AreaFacets.*;
import static facets.facet.FacetFactory.*;
import static facets.facet.app.FacetConstants.*;
import static java.awt.Cursor.*;
import static javax.swing.BorderFactory.*;
import facets.core.app.ActionAppSurface;
import facets.core.app.Dialogs;
import facets.core.app.HtmlView;
import facets.core.app.ListView;
import facets.core.app.StatefulViewable;
import facets.core.app.StatefulViewable.Clipper;
import facets.core.app.StatefulViewable.ClipperSource;
import facets.core.app.avatar.AvatarView;
import facets.core.app.TableView;
import facets.core.app.TextTreeView;
import facets.core.app.TextView;
import facets.core.app.TreeView;
import facets.core.superficial.Notifying.Impact;
import facets.core.superficial.SFacet;
import facets.core.superficial.SNumeric;
import facets.core.superficial.SNumeric.Coupler;
import facets.core.superficial.app.SAreaTarget;
import facets.core.superficial.app.SView;
import facets.core.superficial.app.ViewerTarget;
import facets.facet.AreaFacets;
import facets.facet.FacetFactory;
import facets.facet.FacetFactory.AppletHost;
import facets.facet.FacetMaster.Viewer;
import facets.facet.FacetFactory.SurfaceStyle;
import facets.facet.ViewerAreaMaster;
import facets.facet.app.FacetAppSurface;
import facets.facet.app.WindowAppHost;
import facets.facet.toolkit.Decoration;
import facets.facet.toolkit.KButton;
import facets.facet.toolkit.KField;
import facets.facet.toolkit.KList;
import facets.facet.toolkit.KMount;
import facets.facet.toolkit.KTargetable;
import facets.facet.toolkit.KViewer;
import facets.facet.toolkit.KWidget;
import facets.facet.toolkit.KWrap;
import facets.facet.toolkit.KWrap.ItemSource;
import facets.facet.toolkit.Kit;
import facets.facet.toolkit.KitFacet;
import facets.facet.toolkit.avatar.SwingPainterSource;
import facets.facet.toolkit.swing.Spacer.Filler;
import facets.facet.toolkit.swing.tree.PathListPaneMaster;
import facets.facet.toolkit.swing.tree.PathTreePaneMaster;
import facets.util.Debug;
import facets.util.IndexingIterator;
import facets.util.ItemList.TreeItems;
import facets.util.NumberPolicy;
import facets.util.Objects;
import facets.util.StringFlags;
import facets.util.Times;
import facets.util.Util;
import facets.util.app.AppWatcher;
import facets.util.app.BusyCursor;
import facets.util.datatree.ValueNode;
import java.awt.AWTEvent;
import java.awt.BorderLayout;
import java.awt.CardLayout;
import java.awt.Color;
import java.awt.Component;
import java.awt.Container;
import java.awt.Cursor;
import java.awt.FlowLayout;
import java.awt.Font;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.GridLayout;
import java.net.URL;
import java.util.ArrayList;
import java.util.List;
import javax.swing.Icon;
import javax.swing.ImageIcon;
import javax.swing.JComponent;
import javax.swing.JLabel;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JPanel;
import javax.swing.JPopupMenu;
import javax.swing.JTabbedPane;
import javax.swing.JTextArea;
import javax.swing.JTextField;
import javax.swing.JToolBar;
import javax.swing.KeyStroke;
import javax.swing.SwingConstants;
import javax.swing.UIManager;
import javax.swing.border.BevelBorder;
import javax.swing.border.Border;
import javax.swing.border.EtchedBorder;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;
import javax.swing.event.PopupMenuEvent;
import javax.swing.event.PopupMenuListener;
final public class KitSwing extends Kit{
	private static boolean setSystemLaF;
	private static final float windowsStdKitFontFloat=11;
	private static float kitFontFloat;
	public static void adjustFont(Component c){
		if(!setSystemLaF)return;
		c.setFont(c.getFont().deriveFont(kitFontFloat));
		if(c instanceof Container)
			for(Component d:((Container)c).getComponents())
				d.setFont(d.getFont().deriveFont(kitFontFloat));
	}
	public double layoutFactor(){
		return layoutFactorSwing();
	}
	static double layoutFactorSwing(){
		return setSystemLaF?kitFontFloat/windowsStdKitFontFloat:1.2;
	}
	protected int newKitFontSize(){
		return new JMenuBar().getFont().getSize();
	}
	final public AppWatcher watcher;
	public KitSwing(boolean systemLookAndFeel,boolean forApplet){
		watcher=new AppWatcherSwing(forApplet);
		if(true&&systemLookAndFeel)try{
			String lafName=UIManager.getSystemLookAndFeelClassName();
			UIManager.setLookAndFeel(lafName);
			setSystemLaF=true;
		}catch(Exception notSet){
			trace(notSet+" in "+Debug.info(this));
		}
		kitFontFloat=false?windowsStdKitFontFloat:newKitFontSize();
		FacetFactory.fillFontSizes((int)(kitFontFloat+(inWindows?1:0)));
	}
	private ViewerMaster newTextMaster(final SView view){
		return new ViewerMaster(){
			protected JComponent newAvatarPane(){
				JTextArea pane=new JTextArea(){{
					if(false)enableEvents(AWTEvent.MOUSE_EVENT_MASK|
							AWTEvent.MOUSE_MOTION_EVENT_MASK);
				}};
				pane.setEditable(viewerTarget().view().isLive());
				pane.setFont(new Font(true?"Dialog":"Courier New",Font.PLAIN,
						fontSizes[fontSizeAt]));
				return pane;
			}
			public void refreshAvatars(Impact impact){
				new TextPaneUpdate(viewerTarget().selection()){
					protected void updatePaneText(String now){
						final JTextArea pane=(JTextArea)avatarPane();
						String then=pane.getText();
						if(!then.equals(now)){
							pane.setText(now);
							pane.setLineWrap(((TextView)view).wrapLines());
							pane.setCaretPosition(0);
						}
					}
				}.updatePane();
			}
		};
	}
	protected void traceOutput(String msg){
		if(true)super.traceOutput(msg);
		else if(false)Times.printElapsed("KitSwing: "+msg);
	}
	public KWrap menu(final KitFacet facet,String title,final ItemSource itemSource,
			final StringFlags hints){
		if(title==null||title=="")throw new RuntimeException("No title in "+facet);
		Decoration decorator=decoration(title,hints);
		final JMenu swing=new JMenu(decorator.caption);
		if(surfaceStyle==SurfaceStyle.DESKTOP)swing.setMnemonic(decorator.mnemonic);
		final JPopupMenu popup=swing.getPopupMenu();
		if(panelShade!=null){
			swing.setBackground(new Color(panelShade.rgb()));
			popup.setBackground(new Color(panelShade.rgb()));
		}
		PopupMenuListener listener=new PopupMenuListener(){
			private KWrap[]itemsThen;
			public void popupMenuCanceled(PopupMenuEvent e){}
			public void popupMenuWillBecomeInvisible(PopupMenuEvent e){}
			public void popupMenuWillBecomeVisible(PopupMenuEvent e){
				if(false)swing.requestFocusInWindow();
				KWrap[]items=itemSource.getItems();
				if(false&&hints.includeFlag(HINT_DEBUG))trace(".popupMenuWillBecomeVisible: items=",items);
				if(items==itemsThen)return;
				itemsThen=items;
				popup.removeAll();
				for(int i=0;i<items.length;i++)
					if(items[i]==KWidget.BREAK)popup.addSeparator();
					else popup.add((JMenuItem)items[i].wrapped());
			}
		};
		listener.popupMenuWillBecomeVisible(null);
		popup.addPopupMenuListener(listener);
		return new Widget(facet,swing);
	}
	BusyCursor newBusyCursor(final Container swing,final JMenuBar swingMenus){
		if(swingMenus!=null)((AppWatcherSwing)watcher).blockParent=swing;
		return new BusyCursor(){
			protected void setCursor(boolean busy){
				if(false&&busy)traceDebug(".setCursor: swing=",swing);
				Cursor set=getPredefinedCursor(busy?WAIT_CURSOR:DEFAULT_CURSOR);
				if(swingMenus!=null)swingMenus.setCursor(set);
				Container components[]=KitSwing.allComponents(swing);
				for(Container c:components)
					if(false&&!c.isVisible())continue;
					else if(c.getComponents().length>0||c instanceof JPanel)c.setCursor(set);
				if(false&&busy)trace(".~setCursor: components=",components.length);
			}
		};
	}
	public void adjustMenuMnemonics(KWrap[]wraps){
		class ItemProxy{
			Decoration d;
			ItemProxy(KWrap wrap){
				d=((Widget)wrap).decorations;
				if(false)trace("ItemProxy: "+this);
			}
			public String toString(){
				return d.toString();
			}
		}
		List<ItemProxy>items=new ArrayList();
		for(KWrap wrap:wraps)
			if(wrap instanceof Widget)items.add(new ItemProxy(wrap));
	}
	public KWrap asWrap(KitFacet facet,Object part){
		return part instanceof Widget||part instanceof ViewerBase?(KWrap)part
				:new Widget(facet,(JComponent)part);
	}
	protected KButton newButton(KitFacet facet,int type,int usage){
		return new Button(facet,type,usage);
	}
	public KField colorShader(KitFacet facet,StringFlags hints){
		KButton button=buttons(facet,KButton.TYPE_FIRE,KButton.USAGE_PANEL,
				new String[]{"Set Shade"},hints)[0];
		return new FieldShader(facet,button);
	}
	public KList dropdownList(KitFacet dropdown,boolean asCombo,StringFlags hints){
		return new ListDropdown(this,dropdown,asCombo,hints);
	}
	public KWrap filler(KitFacet facet){
		return new Filler(facet);
	}
	public KViewer masteredViewer(KitFacet facet,ViewerAreaMaster vam,final SView view,
			ValueNode stateNode){
		StringFlags hints=vam.hints();
		Viewer master=vam.viewerMaster();
		if(master==null)master=view instanceof AvatarView?
				SwingPainterSource.planeMaster(facet,vam.hints())
			:view instanceof TextView?
				view instanceof HtmlView?new HtmlPaneMaster(this,hints)
		  	:newTextMaster(view)
			:view instanceof TreeView?
				view instanceof TextTreeView?new HtmlTreePaneMaster()
				:view instanceof ListView?new PathListPaneMaster()
				:new PathTreePaneMaster(hints.includeFlag(HINT_EXTRAS_PANE))
		  :view instanceof TableView?new TablePaneMaster(stateNode,
		  				(AreaFacets.TABLE_KEY_COLUMNS+Util.shortTypeNameKey(vam)))
		  :null;
		if(master==null)throw new IllegalStateException
			("Invalid view " + Debug.info(view)+" in "+Debug.info(this));
		return new ViewerBase(facet,(ViewerMaster)master,this,hints);
	}
	public AppletHost appletHostWrap(FacetFactory ff,JMenuBar menuBar){
		return new HostWrap(this,menuBar);
	}
	public WindowAppHost newWindowHost(FacetAppSurface app){
		return new WindowHostSwing(app,this);
	}
	public KWrap label(KitFacet facet,String title,StringFlags hints){
		return new Label(facet,decoration(title,hints));
	}
	public KWrap nudgersPanel(KitFacet facet,KWrap[]buttons,KWrap[]boxes,
			KWrap[]labels,StringFlags hints){
		final boolean boxed=boxes!=null,bare=labels==null,
			tall=hints.includeFlag(HINT_TALL),
			square=hints.includeFlag(HINT_SQUARE),
			nudgersFirst=hints.includeFlag(HINT_NUMERIC_NUDGERS_FIRST),
			debug=hints.includeFlag(HINT_DEBUG);
		if(debug)trace(".nudgersPanel: ",
				"boxed="+boxed+",bare="+bare+",tall="+tall+",square="+square
		);
		JPanel swing=new JPanel(new GridBagLayout());
		for(int n=0;n<buttons.length/2;n++){
			JPanel nudgers=new JPanel(new GridLayout(tall?2:1,tall?1:2,0,0));
			Kit.widgets++;
			if(panelShade!=null)nudgers.setBackground(new Color(panelShade.rgb()));
			nudgers.add((Component)buttons[n*2].wrapped());
			nudgers.add((Component)buttons[n*2+1].wrapped());
			final int nAt=n,wideX=(2+(bare?0:2)+(boxed?1:0))*n;
			swing.add(nudgers,new GridBagConstraints(){{
				gridx=tall||square?
						!boxed&&bare?0:(boxed&&bare)||tall?1:2
					:wideX+(bare?0:2)+(boxed&&!nudgersFirst?1:0);
				gridy=tall||square?nAt:0;
				fill=BOTH;
			}});
			Component swingLabel=labels==null?null:(Component)labels[n].wrapped();
			if(boxed){
				KWrap box=boxes[n];
				if(tall){
					RowMount boxBase=new RowMount(NO_FACET,0,5,
							new StringFlags(HINT_PANEL_CENTER));
					boxBase.setItems(bare?new KWrap[]{box}:new KWrap[]{labels[n],
							KWrap.BREAK,box});
					swing.add((Component)boxBase.wrapped(),new GridBagConstraints(){{
							gridx=0;
							gridy=nAt;
							ipadx=15;
						}});
				}else{
					Container swingBox=(Container)box.wrapped();
					((JTextField)allComponents(swingBox)[1]).setHorizontalAlignment(
							SwingConstants.CENTER);
					if(square){
						if(!bare)swing.add(swingLabel,
								new GridBagConstraints(){{
								gridx=0;
								gridy=nAt;
								ipadx=2;
								anchor=EAST;
							}});
						swing.add(swingBox,new GridBagConstraints(){{
								gridx=bare?0:1;
								gridy=0;
								ipadx=6;
							}});
					}
					else {
						if(!bare)
							swing.add(swingLabel,
									new GridBagConstraints(){{
									gridx=wideX;
									gridy=0;
									ipadx=4;
									anchor=EAST;
								}});
						swing.add(swingBox,new GridBagConstraints(){{
								gridx=wideX+(bare?0:1)+(nudgersFirst?2:0);
								gridy=0;
								ipadx=0;
							}});
					}
				}
			}
			else if(!bare)
				swing.add(swingLabel,new GridBagConstraints(){{
						gridx=0;
						gridy=nAt;
						anchor=EAST;
						ipadx=5;
					}});
		}
		return new Widget(facet,swing);
	}
	public KField numberField(KitFacet facet,NumberPolicy policy,
			StringFlags hints){
		return new FieldNumber(facet,policy,this,hints);
	}
	public KMount rootMount(ActionAppSurface app,KitFacet facet,
			boolean desktop){
		return new AppMount(app,this,facet,desktop);
	}
	public KMount rowMount(KitFacet facet,int hgap,int vgap,StringFlags hints){
		return new RowMount(facet,hgap,vgap,hints);
	}
	public KWrap wrapMount(KitFacet facet,KWrap[]wraps,int hgap,
			int vgap,StringFlags hints){
		return new WrapMount(facet,decoration(facet.title(),hints),wraps,hgap,vgap);
	}
	public KMount spreadMount(KitFacet facet,StringFlags hints){
		return new SpreadMount(facet,this,hints);
	}
	public KMount packedMount(KitFacet facet,StringFlags hints){
		return new PackedMount(facet,hints);
	}
	public KTargetable sliderPanel(KitFacet facet,int width,KWrap label,
			KWrap box,StringFlags hints){
		return new SliderPanel(facet,width,label,box,hints);
	}
	public KWrap spacer(KitFacet facet,int width,int height){
		double factor=layoutFactor();
		return new Spacer(facet,(int)(width*factor),(int)(height*factor));
	}
	public KMount splitMount(KitFacet facet,boolean wide,SNumeric ratio){
		if(ratio==null)ratio=new SNumeric("splitMountDefault",50,new Coupler(){
			public NumberPolicy policy(SNumeric n){
				return SASH_SPLIT_POLICY;
			}
			public void valueSet(SNumeric n){}
		});
		return new SplitMount(facet,wide,ratio);
	}
	public KMount areaTabs(final SFacet[]areas,final StringFlags hints){
		return new AreaTabs(this,areas,hints);
	}
	public KMount tabMount(final KWrap[]items,final String[]titles){
		return new MountCore(NO_FACET,new JTabbedPane(SwingConstants.TOP){{
				adjustFont(this);
				new IndexingIterator<KWrap>(items){
					protected void itemIterated(KWrap item,int at){
						Decoration decorations=decoration(titles[at],StringFlags.EMPTY);
						Kit.widgets++;
						addTab(decorations.caption,(Icon)decorations.icon,
								(Component)item.wrapped());
					}
				}.iterateWithIndex();
			}
		});
	}
	public KMount switchMount(final KitFacet facet,KWrap[]items,final StringFlags hints){
		final CardLayout layout=new CardLayout();
		final JPanel switcher=new JPanel(layout),
			swing=new JPanel(new BorderLayout()),
			headerBase=new JPanel(new FlowLayout(0,5,5));
		swing.add(switcher,BorderLayout.CENTER);
		final JLabel header=new JLabel();
		headerBase.add(header);
		if(false)headerBase.setBorder(false?createEtchedBorder(EtchedBorder.LOWERED)
				:createBevelBorder(BevelBorder.LOWERED));
		adjustFont(header);
		Font font=header.getFont();
		header.setFont(new Font(font.getFontName(),Font.BOLD,(int)(font.getSize()*1.5)));
		MountCore mount=new MountCore(facet,swing){
			public void setActiveItem(KWrap item){
				layout.show(switcher,""+Debug.id(item));
				header.setText(decoration(item.facet().title(),hints).caption);
			}
		};
		if(items==null)return mount;
		if(items.length>1&&!hints.includeFlag(HINT_BARE))
			swing.add(headerBase,BorderLayout.NORTH);
		for(KWrap item:items)
			switcher.add((Component)item.wrapped(),""+Debug.id(item));
		mount.setActiveItem(items[0]);
		return mount;
	}
	public KField textField(KitFacet facet,int cols,StringFlags hints){
		return new FieldText(facet,cols,this,hints);
	}
	public KField textLabel(KitFacet facet,StringFlags hints){
		return new Label(facet,hints);
	}
	public KWrap toolBarBase(KitFacet facet,KMount addBase){
		JToolBar swing=new JToolBar();
		swing.add((Container)addBase.wrapped());
		return new Widget(facet,swing);
	}
	public KWrap viewerTabs(final SFacet[]viewerAreas){
		final JTabbedPane tabBase=new JTabbedPane(SwingConstants.BOTTOM);
		for(int i=0;i<viewerAreas.length;i++){
			KitFacet area=(KitFacet)((ViewerTarget)((SAreaTarget)(
					(KitFacet)viewerAreas[i]).target()).activeFacet()).attachedFacet();
			ViewerBase swing=(ViewerBase)area.base();
			boolean wrapped=swing.isLabelMounted();
			Container base=(Container)swing.wrapped(),
				addTab=!wrapped?base:(Container)base.getComponent(0);
			if(wrapped) base.removeAll();
			String title="Title me!";
			final boolean isShared=false;
			Object icon=getDecorationIcon(isShared?AreaFacets.PAGES_SHARED
					:AreaFacets.PAGES_SINGLE, false);
			if(icon==null)tabBase.addTab(title,addTab);
			else tabBase.addTab(title,(Icon)icon,addTab);
		}
		tabBase.addChangeListener(new ChangeListener(){
			public void stateChanged(ChangeEvent e){
				((KitFacet)viewerAreas[tabBase.getSelectedIndex()]).targetNotify(tabBase,false);
			}
		});
		return asWrap(NO_FACET,tabBase);
	}
	public KList listPane(KitFacet facet,int width,int rows){
		return new ListPane(facet,this,width,rows,false);
	}
	public KList listPaneMultiple(KitFacet facet,int width,int rows){
		return new ListPane(facet,this,width,rows,true);
	}
	public KList listPaneChecked(KitFacet facet,int width,int rows){
		return new ListPaneTable(facet,this,width,rows);
	}
	@Override
	protected Object getDecorationKeyStroke(String key){
		Integer code=keyCodes.get(key);
		if(code==null)return null;
		int keyValue=code&0xFFFF,
			mask=(code&KEY_CTRL)>>16|(code&KEY_SHIFT)>>16;
		if(false)trace("SwingKit: key=",key+",mask="+mask);
		return KeyStroke.getKeyStroke(keyValue,mask);
	}
	protected Object newFileIcon(String fileSpec){
		return new ImageIcon(fileSpec);
	}
	protected Object newDecorationIcon(URL url){
		return new ImageIcon(url);
	}
	public ClipperSource statefulClipperSource(final boolean useSystemClipboard){
		return new ClipperSource(){
			public Clipper newClipper(StatefulViewable viewable){
				return new ClipperSwing(viewable,useSystemClipboard);
			}
		};
	}
	public void warningCritical(Dialogs.ExceptionTexts tt,Exception e,boolean inOpen){
		DialogsSwing.warningExceptionSwing(tt,e,null,inOpen);
	}
	static void addToolGroups(JComponent panel,Component...groups){
		final Border groupBorder=createEmptyBorder(0,0,0,5);
		panel.setLayout(new FlowLayout(FlowLayout.LEFT,2,0));
		if(groups.length==1){
			if(false)panel.setBorder(groupBorder);
			panel.add(groups[0]);
			panel.validate();
			return;
		}
		panel.setBorder(createEmptyBorder(2,2,2,2));
		for(int i=0;i<groups.length;i++) {
			((JComponent)groups[i]).setBorder(groupBorder);
			panel.add(groups[i]);
			panel.validate();
		}
	}
	static Container[]allComponents(Container root){
		return new TreeItems<Container>(Container.class,root){
			@Override
			protected Container[]getChildren(Container parent){
				return Objects.newTyped(itemType,parent.getComponents());
			}
		}.items();
	}
}
/*/*
This file forms part of Version 0.8.79 of Facets, a framework demonstrating 
the Superficial approach to GUI-driven interactive applications.  
http://superficial.sourceforge.net 				
Copyright (C) 2011  David M Wright 
This library is free software; you can redistribute it and/or modify it under 
the terms of the GNU Lesser General Public License as published by the 
Free Software Foundation; either release 3 of the License, or (at your 
option) any later release.
This library is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR 
A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more 
details.
You should have received a copy of the GNU Lesser General Public License along 
with this library; if not, write to the Free Software Foundation, Inc., 
59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/

