package facets.facet.toolkit.swing;
import static facets.facet.FacetFactory.*;
import facets.facet.toolkit.Decoration;
import facets.facet.toolkit.KField;
import facets.facet.toolkit.KitFacet;
import facets.util.Debug;
import facets.util.StringFlags;
import java.awt.Graphics;
import java.awt.Rectangle;
import javax.swing.BorderFactory;
import javax.swing.JLabel;
import javax.swing.border.Border;
final class Label extends Widget implements KField{
	Label(KitFacet facet,Decoration d){
		this(facet,StringFlags.EMPTY);
		redecorate(d);
	}
	Label(KitFacet facet,StringFlags hints){
		super(facet,null);
		final boolean autoclear=hints.includeFlag(HINT_LABEL_AUTOCLEAR);
		debug=hints.includeFlag(HINT_DEBUG);
		JLabel swing=new JLabel(Debug.info(facet)){
			private String thenText;
			public void setText(String text){
				super.setText(text);
				if(autoclear&&thenText==text){
					Graphics g=getGraphics();
					if(g!=null){
						Rectangle b=getBounds();
						g.clearRect(b.x,b.y,b.width,b.height);
						paint(g);
					} 
				}
				thenText=text;
			}
			protected void paintComponent(Graphics g){
				if(debug)trace("..paintComponent: ");
				super.paintComponent(g);
			}
		};
		KitSwing.adjustFont(swing);
		setSwing(swing);
	}
	public void redecorate(Decoration d){
		setText(d.caption);
		if(!d.rubric.equals(""))((JLabel)swing).setToolTipText(d.rubric);
	}
	public void setText(String text){
		if(debug)trace(".setText:" ,Debug.info(this)+" "+text);
		((JLabel)swing).setText(text);
	}
	public String toString(){
		return super.toString()+" "+((JLabel)swing).getText();
	}
	public String text(){
		throw new RuntimeException("Not implemented in "+Debug.info(this));
	}
	public double value(){
		throw new RuntimeException("Not implemented in "+Debug.info(this));
	}
	public void makeEditable(){
		throw new RuntimeException("Not implemented in "+Debug.info(this));		
	}
	public void setValue(double value){
		throw new RuntimeException("Not implemented in "+Debug.info(this));		
	}
}
/*/*
This file forms part of Version 0.8.79 of Facets, a framework demonstrating 
the Superficial approach to GUI-driven interactive applications.  
http://superficial.sourceforge.net 				
Copyright (C) 2011  David M Wright 
This library is free software; you can redistribute it and/or modify it under 
the terms of the GNU Lesser General Public License as published by the 
Free Software Foundation; either release 3 of the License, or (at your 
option) any later release.
This library is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR 
A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more 
details.
You should have received a copy of the GNU Lesser General Public License along 
with this library; if not, write to the Free Software Foundation, Inc., 
59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/

