package facets.facet.toolkit.swing;
import static facets.facet.FacetFactory.*;

import facets.facet.toolkit.KWrap;
import facets.facet.toolkit.Kit;
import facets.facet.toolkit.KitFacet;
import facets.util.Debug;
import facets.util.StringFlags;
import facets.util.Util;

import java.awt.BorderLayout;
import java.awt.Component;
import java.awt.Container;
import java.awt.FlowLayout;
import java.awt.Insets;
import javax.swing.BorderFactory;
import javax.swing.JComponent;
import javax.swing.JPanel;
class SpreadMount extends MountCore{
	private final StringFlags hints;
	private JComponent swingItem;
	SpreadMount(KitFacet facet,Kit kit,final StringFlags hints){
		super(facet,new JPanel(new BorderLayout()));
		if(false)((JComponent)swing).setOpaque(false);
		this.hints=hints;
		debug=hints.includeFlag(HINT_DEBUG);
		if(hints.includeFlag(HINT_PANEL_INSET)){
			int in=(int)(10*kit.layoutFactor());
			((JPanel)swing).setBorder(BorderFactory.createEmptyBorder(in,in,in,in));
		}
	}
	public void setItem(KWrap item){
		swing.removeAll();
		if(item==null)return;
		swingItem=(JComponent)item.wrapped();
		setHidden(false);
	}
	public void setHidden(boolean hidden){
		swing.removeAll();
		if(!hidden)swing.add(swingItem,BorderLayout.CENTER);
		if(debug)trace(".setHidden: hidden="+hidden+" swingItem="+Debug.info(swingItem)+
				" swing=",swing.getComponentCount());
		swing.validate();
		swingItem.setVisible(!hidden);
	}
	public void setTools(KWrap tools,StringFlags hints){
		JComponent panel=new JPanel();
		KitSwing.addToolGroups(panel,((JComponent)tools.wrapped()).getComponents());
		swing.add(panel,hints.includeFlag(HINT_PANEL_RIGHT)?BorderLayout.EAST
				:hints.includeFlag(HINT_PANEL_ABOVE)?BorderLayout.NORTH
						:BorderLayout.SOUTH);
	}
	public void setItems(KWrap... items){
		super.setItems(items);
		Container[]all=KitSwing.allComponents(swing);
		for(int i=0;i<all.length;i++)KitSwing.adjustFont(all[i]);
	
	}
}/*/*
This file forms part of Version 0.8.79 of Facets, a framework demonstrating 
the Superficial approach to GUI-driven interactive applications.  
http://superficial.sourceforge.net 				
Copyright (C) 2011  David M Wright 
This library is free software; you can redistribute it and/or modify it under 
the terms of the GNU Lesser General Public License as published by the 
Free Software Foundation; either release 3 of the License, or (at your 
option) any later release.
This library is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR 
A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more 
details.
You should have received a copy of the GNU Lesser General Public License along 
with this library; if not, write to the Free Software Foundation, Inc., 
59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/
