package facets.facet.toolkit.swing;
import static facets.facet.FacetFactory.*;
import static java.awt.event.MouseEvent.*;
import facets.core.superficial.app.SAreaTarget;
import facets.facet.FacetFactory;
import facets.facet.app.FacetAppActions;
import facets.facet.app.FacetAppSurface;
import facets.facet.toolkit.Decoration;
import facets.facet.toolkit.KWrap;
import facets.facet.toolkit.Kit;
import facets.util.Debug;
import facets.util.StringFlags;
import facets.util.Util;
import java.awt.AWTEvent;
import java.awt.Color;
import java.awt.Component;
import java.awt.FlowLayout;
import java.awt.Font;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.RenderingHints;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import javax.swing.Icon;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTabbedPane;
final class TabCloserItem extends JPanel{
	private final MouseListener mouseListener=new MouseAdapter(){
		public void mouseEntered(MouseEvent e){
			close.setIcon(e.getSource()==close?closeIconHi:closeIconLo);
		}
		public void mouseExited(MouseEvent e){
			close.setIcon(blankIcon);
		}
		public void mouseClicked(MouseEvent e){
			tabs.setSelectedComponent((Component)item.wrapped());
      item.facet().targetNotify(item,false);
			if(e.getSource()==close)appActions.windowTryClose();
		}
	};
	private final JTabbedPane tabs;
	private final Kit kit;
	private final KWrap item;
	private final JLabel caption,close;
	private final Icon blankIcon,closeIconLo,closeIconHi;
	private final FacetAppActions appActions;
	TabCloserItem(JTabbedPane tabs,KWrap[]items,int at,Kit kit,
			FacetAppSurface app){
		super(new FlowLayout(0,0,0));
		this.tabs=tabs;
		this.kit=kit;
		this.appActions=((FacetAppActions)app.actions);
		item=items[at];
		tabs.addTab(null,(Component)item.wrapped());
		tabs.setTabComponentAt(at,this);
		setOpaque(false);
		addMouseListener(mouseListener);
		caption=new JLabel(Debug.info(this),0);
		KitSwing.adjustFont(caption);
		add(caption);
		add(new JLabel(""));
		blankIcon=newTabIcon(kit,"");
		closeIconLo=newTabIcon(kit,KEY_TAB_CLOSE_LO);
		closeIconHi=newTabIcon(kit,KEY_TAB_CLOSE_HI);
		close=new JLabel(blankIcon,0);
		if(items.length==1)return;
		add(close);
		caption.addMouseListener(mouseListener);
		close.addMouseListener(mouseListener);
		close.setToolTipText(kit.getDecorationTitle(KEY_TAB_CLOSE_LO));
		update();
	}
	void update(){
		String title=item.facet().title();
		caption.setText(kit.decoration(title,StringFlags.EMPTY).tabCaption());
		caption.setIcon((Icon)kit.getDecorationIcon(title.replace("([^.]+).*","$1"), false));
		caption.setToolTipText(title.replaceAll("([^:]+).*","$1"));
	}
	private Icon newTabIcon(Kit kit,final String key){
		Icon got=(Icon)kit.getDecorationIcon(key, false);
		return got!=null?got:new Icon(){
			public int getIconHeight(){
				return 16;
			}
			public int getIconWidth(){
				return 16;
			}
			public void paintIcon(Component c,Graphics g,int x,int y){
				if(key.equals(""))return;
				Graphics2D g2=(Graphics2D)g.create();
				g2.setRenderingHint(RenderingHints.KEY_ANTIALIASING,
				    RenderingHints.VALUE_ANTIALIAS_ON);
				g2.setFont(new Font("SansSerif",Font.BOLD,12));
				g2.setColor(key.equals(KEY_TAB_CLOSE_LO)?Color.LIGHT_GRAY:Color.RED);
				g2.drawString("X",x+5,y+13);
			}
		};
	}
}/*/*
This file forms part of Version 0.8.79 of Facets, a framework demonstrating 
the Superficial approach to GUI-driven interactive applications.  
http://superficial.sourceforge.net 				
Copyright (C) 2011  David M Wright 
This library is free software; you can redistribute it and/or modify it under 
the terms of the GNU Lesser General Public License as published by the 
Free Software Foundation; either release 3 of the License, or (at your 
option) any later release.
This library is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR 
A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more 
details.
You should have received a copy of the GNU Lesser General Public License along 
with this library; if not, write to the Free Software Foundation, Inc., 
59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/
