package facets.facet.toolkit.swing;
import facets.core.superficial.SFacet;
import facets.core.superficial.STarget;
import facets.core.superficial.app.SViewer;
import facets.core.superficial.app.ViewerTarget;
import facets.facet.FacetFactory;
import facets.facet.FacetMaster;
import facets.util.Debug;
import facets.util.Util;
import java.io.Serializable;
import javax.swing.JComponent;
import javax.swing.JScrollPane;
public abstract class ViewerMaster extends FacetMaster.Viewer{
	ViewerBase base;
	protected abstract JComponent newAvatarPane();
	public JComponent avatarPane(){
		return base().avatarPane;		
	}
	final public ViewerTarget viewerTarget(){
		return(ViewerTarget)base().facet.target();
	}
	final public void focusGained(){
		traceDebug(".focusGained: ",this);
		base().focusGained(null);		
	}
	public final ViewerBase base(){
		if(base==null)throw new IllegalStateException(
				"No base in (unattached?) "+Debug.info(this));
		else return base;
	}
	final public void requestPopup(int atX,int atY){
		base().popupRequested(atX,atY);		
	}
	public boolean isScrollable(){
		return true;
	}
	final public JScrollPane scrollPane(){
		JScrollPane scroll=base.scroll;
		if(scroll==null)throw new IllegalStateException("Null scroll in "+Debug.info(this));
		return scroll;
	}
	protected STarget[]targets(){
		return new STarget[]{};
	}
	public SFacet[]getTargetFacets(FacetFactory ff){
		return null;
	}
	protected int defaultCursor(){
		return -1;
	}
}
/*/*
This file forms part of Version 0.8.79 of Facets, a framework demonstrating 
the Superficial approach to GUI-driven interactive applications.  
http://superficial.sourceforge.net 				
Copyright (C) 2011  David M Wright 
This library is free software; you can redistribute it and/or modify it under 
the terms of the GNU Lesser General Public License as published by the 
Free Software Foundation; either release 3 of the License, or (at your 
option) any later release.
This library is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR 
A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more 
details.
You should have received a copy of the GNU Lesser General Public License along 
with this library; if not, write to the Free Software Foundation, Inc., 
59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/

