package facets.facet.toolkit.swing;
import static facets.facet.FacetFactory.*;
import facets.facet.SwingPanelFacet;
import facets.facet.toolkit.Decoration;
import facets.facet.toolkit.KWrap;
import facets.facet.toolkit.Kit;
import facets.facet.toolkit.KitFacet;
import facets.util.Debug;
import facets.util.StringFlags;
import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.FlowLayout;
import java.awt.GridLayout;
import java.awt.Insets;
import java.awt.LayoutManager;
import javax.swing.BorderFactory;
import javax.swing.Box;
import javax.swing.JComponent;
import javax.swing.JLabel;
import javax.swing.JPanel;
final class WrapMount extends Widget{
	private final JLabel label;
	private final boolean formUsage,debug;
  WrapMount(KitFacet facet,Decoration decorations,KWrap[]wraps,int hgap,int vgap){  	  	
		super(facet,null);
		StringFlags hints=decorations.hints;
		hgap=(int)(hgap*KitSwing.layoutFactorSwing());
		vgap=(int)(vgap*KitSwing.layoutFactorSwing());
		final boolean 
			grid=hints.includeFlag(HINT_GRID),
			square=hints.includeFlag(HINT_SQUARE),
			spread=hints.includeFlag(HINT_SPREAD),
			wide=!spread&&!hints.includeFlag(HINT_TALL),
			bare=!spread&&hints.includeFlag(HINT_BARE);
		if(spread&&wraps.length>1)throw new IllegalArgumentException(
				"Cannot spread multiple wraps "+Debug.info(this));
		debug=hints.includeFlag(HINT_DEBUG);
		formUsage=hints.includeFlag(HINT_USAGE_FORM);
	  int rows=wide?1:wraps.length,cols=wide?wraps.length:1;
	  if(square)switch(wraps.length){
		  case 3:case 4:rows=2;cols=2;break;
		  case 5:case 6:rows=3;cols=2;break;
	  }
	  JPanel packed=spread?null
	  		:new JPanel(wide&&!grid?new FlowLayout(FlowLayout.LEFT,hgap,vgap)
	  		:new GridLayout(rows,cols,hgap,vgap));
	  if(packed!=null)for(int i=0;i<wraps.length;i++)packed.add(swingWrapped(wraps[i]));
		if(bare){
	  	label=null;
		  if(panelShade!=null)packed.setBackground(new Color(panelShade.rgb()));
	  	setSwing(packed);
	  	return;
	  }
  	swingMap.put(SwingPanelFacet.KEY_LABELLED,packed);
	  JComponent labelled=new JPanel(wide?new FlowLayout(FlowLayout.LEFT,0,0)
		    :new BorderLayout(0,spread?vgap:0));
	  if(panelShade!=null)labelled.setBackground(new Color(panelShade.rgb()));
	  label=(JLabel)new Label(facet,decorations).wrapped();
	  if(spread){
		  labelled.add(label,BorderLayout.NORTH);
		  labelled.add(swingWrapped(wraps[0]),BorderLayout.CENTER);
	  }
	  else if(wide){
	  	if(debug)trace(".WrapMount: ",hints.includeFlag(HINT_BARE));
	  	labelled.add(label);
	  	labelled.add(Box.createHorizontalStrut(3));
	  	labelled.add(packed);
	  }
	  else{
		  JPanel spaced=new JPanel(new FlowLayout(FlowLayout.LEFT,0,0))
			  {public Insets getInsets(){return new Insets(0,5,0,0);}},
			  spacer=new JPanel(new FlowLayout(FlowLayout.LEFT,0,0))
			  {public Insets getInsets(){return new Insets(0,0,3,0);}};
		  spaced.add(packed);
		  Kit.widgets++;
		  spacer.setBackground(spaced.getBackground());
		  labelled.add(label,BorderLayout.NORTH);
		  if(wraps.length==1)labelled.add(spacer,BorderLayout.CENTER);
		  labelled.add(spaced,BorderLayout.SOUTH);
	  }
	  setSwing(labelled);
  	swingMap.put(SwingPanelFacet.KEY_LABEL,label);
	  Kit.widgets++;
	}
	public void setEnabled(boolean enabled){
		swing.setEnabled(enabled);
		if(label!=null&&!formUsage)label.setEnabled(enabled);
	}
}
/*/*
This file forms part of Version 0.8.79 of Facets, a framework demonstrating 
the Superficial approach to GUI-driven interactive applications.  
http://superficial.sourceforge.net 				
Copyright (C) 2011  David M Wright 
This library is free software; you can redistribute it and/or modify it under 
the terms of the GNU Lesser General Public License as published by the 
Free Software Foundation; either release 3 of the License, or (at your 
option) any later release.
This library is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR 
A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more 
details.
You should have received a copy of the GNU Lesser General Public License along 
with this library; if not, write to the Free Software Foundation, Inc., 
59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/

