package facets.facet.toolkit.swing.tree;
import facets.core.app.NodePath;
import facets.util.Debug;
import facets.util.OffsetPath;
import facets.util.Util;
import facets.util.datatree.Nodes;
import facets.util.datatree.TypedNode;
import javax.swing.JTree;
import javax.swing.event.TreeSelectionEvent;
import javax.swing.tree.TreeModel;
import javax.swing.tree.TreePath;
public class OffsetPathTree extends JTree{
	public OffsetPathTree(TreeModel model){
		super(model);
	}
	public OffsetPath newOffsetPath(TreePath eventPath){
		Object[]members=eventPath.getPath();
		int[]offsets=new int[members.length];
		offsets[0]=0;
		TreeModel model=getModel();
		for(int o=1;o<offsets.length;o++)
			offsets[o]=model.getIndexOfChild(members[o-1],members[o]);
		return newTreeOffsetPath(offsets);
	}
	public void setOffsetPath(OffsetPath offsets){
		setSelectionPath(new TreePath(offsets.members(getModel().getRoot())));
	}
	final public OffsetPath newTreeOffsetPath(int[]offsets){
		return new OffsetPath(offsets){
			@Override
			protected Object[]newMembers(Object root,int[]offsets){
				Object[]members=new Object[offsets.length];
				members[0]=root;
				TreeModel model=getModel();
				for(int i=1;i<members.length;i++)
					members[i]=model.getChild(members[i-1],offsets[i]);
				return members;
			}
			@Override
			protected int[]newOffsets(Object[]members){
				throw new RuntimeException("Not implemented in "+Debug.info(this));
			}
			@Override
			public OffsetPath procrusted(Object root,Object to){
				throw new RuntimeException("Not implemented in "+Debug.info(this));
			}
		};
	}
}
/*/*
This file forms part of Version 0.8.79 of Facets, a framework demonstrating 
the Superficial approach to GUI-driven interactive applications.  
http://superficial.sourceforge.net 				
Copyright (C) 2011  David M Wright 
This library is free software; you can redistribute it and/or modify it under 
the terms of the GNU Lesser General Public License as published by the 
Free Software Foundation; either release 3 of the License, or (at your 
option) any later release.
This library is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR 
A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more 
details.
You should have received a copy of the GNU Lesser General Public License along 
with this library; if not, write to the Free Software Foundation, Inc., 
59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/

