package facets.util;
import static facets.util.Regex.*;
import java.util.HashMap;
import java.util.Map;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
/**
Regular-expression utilities. 
 */
final public class Regex{
	public static final String DOT_ALL="(?s)",AT_START="^",ANYTHING=".*";
	public static String FIX_CHECK="";
	public final static Map<String,Pattern>patterns=new HashMap();
	private static Pattern getPattern(String pattern){
		if(true)return Pattern.compile(pattern);
		Pattern got=patterns.get(pattern);
		if(got!=null)return got;
		patterns.put(pattern,got=Pattern.compile(pattern));
		return got;
	}
	public static String replaceAll(String text,boolean dotAll,String...fixPairs){
		boolean checkMe=!FIX_CHECK.equals("")&&text.contains(FIX_CHECK);
		if(checkMe){
			Util.println("Regex.applyFixes: checking ", FIX_CHECK+" in "+text);
			if(true)Debug.printStackTrace(2);
		}
		for(int i=0;i<fixPairs.length;i+=2){
			text=doReplaceAll(text,(dotAll?DOT_ALL:"")+fixPairs[i],fixPairs[i+1]);
			if(checkMe)Util.println("Regex.applyFixes: '", fixPairs[i]+"' >"+text);
		}
		return text;
	}
	private static String doReplaceAll(String text,String find,String fix){
		return false?text.replaceAll(find,fix)
				:getPattern(find).matcher(text).replaceAll(fix);
	}
	private static String[]finds(String text,String pattern,boolean reverse,
			boolean single){
		if(reverse)text=Strings.reverse(text);
		Matcher m=getPattern(pattern).matcher(text);
		if(single)return new String[]{
				m.find()?!reverse?m.group():Strings.reverse(m.group())
						:""};
		ItemList<String>finds=new ItemList(String.class);		
		while(m.find())
			finds.addItem(!reverse?m.group():Strings.reverse(m.group()));;
		return finds.items();
	}
	public static String replaceAll(String text,String...fixPairs){
		return replaceAll(text,false,fixPairs);
	}
	public static  boolean contains(String text,String pattern){
		return !find(text,pattern).equals("");
	}
	public static String find(String text,String pattern){
		return find(text,pattern,false);
	}
	public static String[]finds(String text,String pattern){
		return finds(text,pattern,false);
	}
	private static String find(String text,String pattern,boolean reverse){
		String[]finds=finds(text,pattern,reverse,true);
		return finds.length==0?"":finds[0];
	}
	public static String[]finds(String text,String pattern,boolean reverse){
		return finds(text,pattern,reverse,false);
	}
	public static String[]captures(String text,String pattern){
		return captures(text,pattern,false);
	}
	public static String[]captures(String text,String pattern,boolean reverse){
		if(reverse)text=Strings.reverse(text);
		Matcher m=getPattern(pattern).matcher(text);
		if(!m.find())return null;
		String[]matches=new String[m.groupCount()];
		for(int i=0;i<matches.length;i++)
			matches[i]=!reverse?m.group(i+1):Strings.reverse(m.group(i+1));
		return matches;
	}
}
/*/*
This file forms part of Version 0.8.79 of Facets, a framework demonstrating 
the Superficial approach to GUI-driven interactive applications.  
http://superficial.sourceforge.net 				
Copyright (C) 2011  David M Wright 
This library is free software; you can redistribute it and/or modify it under 
the terms of the GNU Lesser General Public License as published by the 
Free Software Foundation; either release 3 of the License, or (at your 
option) any later release.
This library is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR 
A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more 
details.
You should have received a copy of the GNU Lesser General Public License along 
with this library; if not, write to the Free Software Foundation, Inc., 
59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/

