package facets.util;
import java.io.File;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.StringTokenizer;
/**
String management and conversion. 
 */
public final class Strings{
	final public static String SPLIT_ARRAY=",",SPLIT_ARRAYS=" \t";
	public static String trimToLength(String text,int max){
		return text.substring(0,Math.min(max,text.length()));
	}
	public static String delete(String from,String what){
		if(from==""||what=="")return from;
		int start=from.indexOf(what),end=start+what.length();
		if(start<0)return from;
		return new StringBuilder(from).delete(start,end).toString();
	}
	public static final String doublesString(double[]vals){
		StringBuilder buffer=new StringBuilder();
		for(int i=0;i<vals.length;i++)buffer.append
			(""+Util.sf(vals[i])+(i<vals.length-1?SPLIT_ARRAY:""));
		return buffer.toString();
  }
  public static String fileExtension(File file){
  	String name=file.getName();
  	int extAt=name.lastIndexOf(".");
  	return extAt<1?"":name.substring(extAt+1);
  }
	public static String fileName(File file){
  	String name=file.getName();
  	if(name.trim().equals(""))name=file.getAbsolutePath();
  	if(name.trim().equals(""))throw new IllegalStateException(
  			"Empty name file="+file);
  	int extAt=name.lastIndexOf(".");
  	return extAt<1?name:name.substring(0,extAt);
  }
  public static String hexString(int bits){
		return Integer.toHexString(bits).toUpperCase();
	}
	public static final String intsString(int[]ints){
		return Objects.toString(ints,SPLIT_ARRAY);
	}
	public static final String[]join(String[]front,String[]back){
		return Objects.join(String.class,front,back);
	}
	public static final String[][]joinArrays(String[][]front,String[][]back){
		return Objects.join(String[].class,front,back);
	}
	public static String linesString(String[]lines){
		return Objects.toString(lines,"\n");
	}
	public static String reverse(String string){
		return new StringBuilder(string).reverse().toString();
	}
	public static String[]sort(String[]strings){
		if(false)return strings;
		ArrayList<String>sorter=new ArrayList(Arrays.asList(strings));
		Collections.sort(sorter);
		return sorter.toArray(new String[]{});
	}
	public static String[]stringLines(String source){
		return source.split("\n");
	}
	public static double[][]toDoubleArrays(String src){
    String[]strings=arrayStrings(src);
    double[][]arrays=new double[strings.length][];
    for(int i=0;i<arrays.length;i++)arrays[i]=toDoubles(strings[i]);
    return arrays;
  }
	public static double[]toDoubles(String src){
		String[]strings=toStrings(src);
		double[]doubles=new double[strings.length];
		for(int i=0;i<doubles.length;i++)doubles[i]=new Double(strings[i]);
		return doubles;
	}
	public static double initialDouble(String text){
		String digits=text.replaceAll("([0-9.]+).*","$1");
		return Double.valueOf(digits);
	}
  public static final int[]toInts(String string){
	  String[]strings=toStrings(string);
	  int[]ints=new int[strings.length];
	  for(int i=0;i<ints.length;i++)ints[i]=new Integer(strings[i].trim());
	  return ints;
  }
  public static final String[]toStrings(String src){
	  return src.split("\\s*" +SPLIT_ARRAY+"\\s*");
	}
  public static final String[]arrayStrings(String src){
	  return src.split("\\s*" +SPLIT_ARRAYS+"\\s*");
  }
  public static String fixEmptyLines(String text){
    return text.replaceAll("[\n\r]\\s*[\n\r]","\n");
  }
	public static boolean equal(String test,String...candidates){
		for(String string:candidates)if(test.equals(string))return true;
		return false;
	}
	public static String newHtmlText(String title,int count){
		StringBuilder sb=new StringBuilder();
		for(int i=1;i<=count;i++)sb.append("\n<p>Line "+i+" of "+count+
				"_____________ _____________ _____________ _____________ _____________ ");
		String html="<html><title>"+title+(true?"":("@"+(System.currentTimeMillis()&0xfff)))+
				"</title><body>"+sb+"\n</body></html>";
		return html;
	}	
}
/*/*
This file forms part of Version 0.8.79 of Facets, a framework demonstrating 
the Superficial approach to GUI-driven interactive applications.  
http://superficial.sourceforge.net 				
Copyright (C) 2011  David M Wright 
This library is free software; you can redistribute it and/or modify it under 
the terms of the GNU Lesser General Public License as published by the 
Free Software Foundation; either release 3 of the License, or (at your 
option) any later release.
This library is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR 
A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more 
details.
You should have received a copy of the GNU Lesser General Public License along 
with this library; if not, write to the Free Software Foundation, Inc., 
59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/

