package facets.util.app;
import facets.util.Debug;
import facets.util.Util;
import facets.util.app.AppWatcher.WatcherCoupler;
	/**
	Wrapper for code to be monitored by {@link AppWatcher}. 
	 */
	public abstract class WatchableOperation{
		/**
		Defines how a {@link WatchableOperation} can be cancelled. 
		 */
		public enum CancelStyle{None,Dialog,Timeout,Future}
		private static int ids=1;
		private final int id=ids++%100;
		private int call;
		private final String title;
		public WatchableOperation(String title){
			this.title=title;
		}
		final Object doOperations(int call){
			this.call=call;
			doSimpleOperation();
			return doReturnableOperation();
		}
		public void doSimpleOperation(){}
		public Object doReturnableOperation(){
			return null;
		}
		public CancelStyle cancelStyle(){
			return CancelStyle.None;
		}
		/**
		Includes the title passed to the constructor and debug detail. 
		 */
		final public String toString(){
			return "#"+id+"c"+call+" "+title;
		}
		public String[]getBlockingCancelTexts(){
			return null;
		}
		protected String[]newContentCreationTexts(String appTitle,Object source){
			return new String[]{
					"Creating Content",
					"Please wait while "+appTitle+" creates content from " +source+".",
					"Cancel Requested",
					"If you cancel this operation, $appTitle may slow down or close without warning.<br>"+
					"Wait for the operation to complete?",
							};
		}
	}/*/*
This file forms part of Version 0.8.79 of Facets, a framework demonstrating 
the Superficial approach to GUI-driven interactive applications.  
http://superficial.sourceforge.net 				
Copyright (C) 2011  David M Wright 
This library is free software; you can redistribute it and/or modify it under 
the terms of the GNU Lesser General Public License as published by the 
Free Software Foundation; either release 3 of the License, or (at your 
option) any later release.
This library is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR 
A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more 
details.
You should have received a copy of the GNU Lesser General Public License along 
with this library; if not, write to the Free Software Foundation, Inc., 
59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/
