package facets.util.datatree;
import facets.util.Util;
import java.util.ArrayList;
import java.util.List;
/**
Facilitates progressive changes in {@link TypedNode} structures. 
 */
public abstract class TreeTransform{
	public final String title;
	public TreeTransform(String title){
		this.title=title;
	}
	public static void applyAll(TypedNode tree,TreeTransform...all){
		List<TreeTransform>apply=new ArrayList();
		for(TreeTransform t:all)
			if(!t.doApply(tree))break;
			else apply.add(0,t);
		for(TreeTransform u:apply){
			Util.println("TreeUpdate: ",u.title);
			u.apply(tree);
		}
	}
	protected abstract void apply(TypedNode tree);
	protected boolean doApply(TypedNode tree){
		return true;
	}
}/*/*
This file forms part of Version 0.8.79 of Facets, a framework demonstrating 
the Superficial approach to GUI-driven interactive applications.  
http://superficial.sourceforge.net 				
Copyright (C) 2011  David M Wright 
This library is free software; you can redistribute it and/or modify it under 
the terms of the GNU Lesser General Public License as published by the 
Free Software Foundation; either release 3 of the License, or (at your 
option) any later release.
This library is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR 
A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more 
details.
You should have received a copy of the GNU Lesser General Public License along 
with this library; if not, write to the Free Software Foundation, Inc., 
59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/
