package facets.util.geom;
import facets.util.Doubles;
import java.io.Serializable;
import java.util.Arrays;
/**
2D Cartesian/polar vector. 
 */
final public class Vector implements Serializable{
  public static int vectors;private final int vector;
  public final double x,y;
	private int hashCode=Integer.MAX_VALUE;
  Vector(){x=Double.NaN;y=Double.NaN;vector=vectors++;}
  public Vector(double x,double y){
		if(x!=x||y!=y) throw new IllegalArgumentException("Not a number");
		this.x=x;this.y=y;
		vector=vectors++;
	}
  public Vector(Vector src){this(src.x,src.y);}
  public Angle bearing(){return new Angle(y,x);}
  public boolean equals(Object o){Vector v=(Vector)o;return x==v.x&&y==v.y;}
  public Vector mean(Vector jump){return new Vector((x+jump.x)/2,(y+jump.y)/2);}
  public Vector minus(Vector jump){return new Vector(x-jump.x,y-jump.y);}
  public Vector plus(Vector jump){return new Vector(x+jump.x,y+jump.y);}
  public double reach(){return Math.sqrt(x*x+y*y);}
  public Vector scaled(double by){return new Vector(x*by,y*by);}
  public String toString(){return"{"+Doubles.sf(x)+","+Doubles.sf(y)+"}";}
	public int hashCode(){
		return hashCode==Integer.MAX_VALUE?
				hashCode=Arrays.hashCode(new Object[]{x,y}):hashCode;
	}
}
/*/*
This file forms part of Version 0.8.79 of Facets, a framework demonstrating 
the Superficial approach to GUI-driven interactive applications.  
http://superficial.sourceforge.net 				
Copyright (C) 2011  David M Wright 
This library is free software; you can redistribute it and/or modify it under 
the terms of the GNU Lesser General Public License as published by the 
Free Software Foundation; either release 3 of the License, or (at your 
option) any later release.
This library is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR 
A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more 
details.
You should have received a copy of the GNU Lesser General Public License along 
with this library; if not, write to the Free Software Foundation, Inc., 
59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/

